# -*- coding: UTF-8 -*-
###########################################################################
# Eole NG - 2007  
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr 
#  
# config.py
#  
# Fichier de conf de l'application web Zephir
#       
###########################################################################
from zephir.config import *

# paths 

TEMPLATE_DIR = ROOT_DIR + "web/template/"
IMAGE_DIR = ROOT_DIR + "web/images/"
HELP_DIR = ROOT_DIR + "web/aide/"
SERVEUR_ZEPHIR = ADRESSE_ZEPHIR
DEFAULT_TIMEOUT = "30"

# Version actuelle des RPMS zephir
import os
if os.path.isfile('/bin/rpm'):
    # Mandrake
    cmd = '/bin/rpm -qa zephir-common >/usr/share/zephir/.version'
else:
    # Sourcemage
    cmd = """echo -n "zephir-parc - " > /usr/share/zephir/.version ; /usr/bin/dpkg-query -W zephir-common | cut -f2 >> /usr/share/zephir/.version"""
res=os.system(cmd)
f=open('/usr/share/zephir/.version')
VERSION_ZEPHIR = f.read()
f.close()

file_icons = {"missing":"stock_calc-cancel.png",
              "dir":"folder.png",
              "file":"gnome-mime-text.png"}

# navigation web

class Navigation:
    def __init__(self,aide=""):
        self.liens = [
            ("accueil", "/"),
            ("serveurs", "/serveur"),
            ("etablissements", "/etab"),
            ("modules", "/module"),
            ("administration","/administration"),
            ("déconnexion","/logout"),
            ]
        if aide != "":
            self.liens.append(("aide","""javascript:void(window.open('/aide/%s','rapport','scrollbars=yes,resizable=yes,location=no,directories=no,status=no'))""" % aide))
 
    def render(self):
        l = []
        l.append("""<center><font face="Tahoma" color="FFFFFF">""")
        for lien in self.liens :
            s = "<a href=%s>%s</a><br/>" %(lien[1], lien[0])
            l.append(s)
        l.append("</font></center>")
        return ("\n").join(l)


    def menu(self):
        l = ["""<center><table border="0" cellspacing="1" cellpadding="0"><tr>"""]
        for lien in self.liens :
            str = """<td>|</td><td><a href="%s">%s</a></td>""" % (lien[1], lien[0])
            l.append(str)
        l.append("<td>|</td></table></center>")
        return ("\n").join(l)

server_sort_keys = {'rne':"code RNE",
                    'module_actuel':"module",
                    'variante':"variante",
                    'id':"identifiant",
                    'libelle':"nom de serveur",
                    'installateur':"installateur",
                    'nb_cmd':"nb de commandes",
                   }
etabs_sort_keys = {'rne':"Indentifiant",
                   'libelle':"Libellé",
                   'ville':"Ville",
                   'cp':"CP",
                   'type':"Type",
                  }

# aide sur la recherche avec wildcards
ilike_syntax ="""Caractères spéciaux : _ remplace un caractère,  % un nombre indéfini de caractères (<a href="javascript:void(window.open('http://docs.postgresqlfr.org/8.3/functions-matching.html','site', 'resizable=yes, location=no, directories=no, status=no, scrollbars=yes'))">plus de détails</a>)"""
