# -*- coding: UTF-8 -*-
###########################################################################
# Eole NG - 2007  
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr 
#  
# index.py
#  
# page principale de l'application web Zephir
#       
###########################################################################
from twisted.web.resource import Resource
from twisted.web import static
from zephir.web.config import Navigation, PATH_TEMP

from zephir.web.html.erreur import *

from zephir.web.template.design import Design, proxy
from zephir.web.html import etabs, utilisateurs, modules, serveurs, services
from os.path import isfile, join
from zephir.eolerpclib import xmlrpclib

class Index(Design):

    def getChild(self, name, request):

        entites = {
            # etablissements
            'etab':etabs.Etab(),
            # utilisateurs
            'administration':utilisateurs.Admin(),
            'preferences':utilisateurs.Preferences(),
            'logout':utilisateurs.Logout(),
            # modules
            'module':modules.Module(),
            # serveurs
            'serveur':serveurs.Serveur(),
            # services
            'services':services.Services(),
            }

        if static.isDangerous(name):
            return static.dangerousPathError
        if name in entites.keys():
            return entites[name]
        return self

    def wmfactory_menu(self, request):
        return Navigation(aide="index.html").menu()

    def wmfactory_title(self,request):
        return "Bienvenue %s" % request.getUser()
  
    def formulaire(self, request, groups, user_groups):
        """ affiche les groupes de serveurs surveillés par l'utilisateur
        """

        # conversion de la liste des groupes de l'utilisateur
        l = ["""<center><table cellpadding='15' cellspacing='0' align='center' valign='middle' width='100%'><!--contenu2--><tr><td align=center>"""]
        l.append("""<table color="#9aacd5" border="1"><tr><td colspan="2" align="center">liste des groupes en surveillance</td></tr>""")

        if user_groups == []:
            l.append("""<tr><td colspan="2" align="center"><b>Aucun groupe selectionné</b></td></tr>""")
        else:
            for groupe in groups:
                if groupe[0] in user_groups:
                    string = """<tr><td><a href="/serveur/aff_groupe?id_groupe=%s">%s</a></td><td align="center"><a href="/serveur/detail_groupe?id=%s">(éditer)</a></td></tr>""" % (str(groupe[0]), groupe[1], str(groupe[0]))
                    l.append(string)

        alertes = backend(proxy(request).serveurs.get_alertes())
        stats = backend(proxy(request).get_stats())
        if len(alertes) > 0:
            alertes = """<a href="/serveur/aff_alertes">serveurs en alerte</a></td><td align="center"><font color="red">%s</font>""" % len(alertes)
        else:
            alertes = """<a href="/serveur/aff_alertes">aucun serveur en alerte</a>"""
        l.append("""<tr><td colspan="2" align="center">statistiques générales</td></tr>""")
        l.append("""<tr><td align="center">nombre total de serveurs</td><td align="center">%s</td></tr>""" % stats['nb_serv'])
        l.append("""<tr><td align="center">serveurs non enregistrés</td><td align="center">%s</td></tr>""" % len(stats['no_contact']))
        l.append("""<tr><td align="center">%s</td></tr>""" % alertes)
        l.append("""<tr><td colspan="2" align="center"><a href="/serveur/aff_migration">suivi de la migration</a></td></tr>""")
        l.append("""</table></td></tr>""")
        l.append("""</table><!--fin:contenu2-->""")

        return "".join(l)
        
    def wmfactory_content(self, request):
        string = "<h1>Zephir Web - Accueil</h1>"
        # + Navigation().render()
        string = """<center><h1>Bienvenue %s</h1>
        <SCRIPT LANGUAGE="JavaScript">
        <!--
        function clear() {
                location.reload(false)
                }
        setTimeout ("clear()", 60000);
        // -->
        </SCRIPT>
        <FORM METHOD="POST" ACTION="/preferences"><input type="submit" value="Vos préférences"></FORM></center>""" % request.getUser()
        # lien sur les groupes surveillés par l'utilisateur
        # session dans self.prefs
        self.prefs=request.getSession()
        # on récupère l'utilisateur courant
        user = request.getUser()
        # calcul de la page
        groups=[]
        info_user=[]
        try:
            groups = backend(proxy(request).serveurs.get_groups())
            info_user = backend(proxy(request).get_user(u(user)))[8]
        except Exception, e:
            pass
        try:
            string += self.formulaire(request, groups, info_user)
        except xmlrpclib.ProtocolError:
            string = """Vous n'êtes pas autorisé à effectuer cette action"""
        except Exception, e:
            string = "erreur frontend : %s" % str(e)
            
        rapport_file = join(PATH_TEMP,"rapport.pdf")
        rapport = """<p><a href="javascript:void(window.open('/aide/howto/index.html','rapport', 'scrollbars=yes, resizable=yes, location=no, directories=no, status=no'))">Tutoriel Zephir</a><br/>"""

        if isfile(rapport_file):
            rapport += """
            </p><p><a href="javascript:void(window.open('%s','rapport', 'scrollbars=yes, resizable=yes, location=no, directories=no, status=no'))">Récupérer le rapport général</a> (<a href=etab/gen_rapport>actualiser</a>)
            </p>
            """ % rapport_file

        else :
            rapport += """
            </p><p><a href=etab/gen_rapport>Générer le rapport général</a><br>(cette action peut prendre du temps)</p>
            """
        return string + rapport

