# -*- coding: UTF-8 -*-
###########################################################################
# Eole NG - 2007  
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr 
#  
# modules.py
#  
# page web de gestion des modules Eole
#       
###########################################################################
from twisted.web import static
from twisted.web.woven import view
from twisted.web.resource import Resource
from zephir.web.template.design import Design, proxy
from zephir.web.config import charset, Navigation, DISTRIBS, file_icons
from zephir.web.html.erreur import *
from zephir.rapports import rapport
from cgi import escape
import dico,sys,os,md5,base64,tempfile
from zephir.eolerpclib import xmlrpclib
from zephir.utils.creolewrap import ZephirDict

class AddModule(Design):
    """Ajout d'un module **page 1**
    """
    isLeaf = True
    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "add" :
            return self
        return Module()

    def wmfactory_title(self,request):
        return "(%s) Nouveau module" % request.getUser()

    def wmfactory_content(self, request):
        # définition des différentes versions de modules disponibles
        versions = DISTRIBS.keys()
        versions.reverse()
        dist_options = ['<option value="%s" selected>%s (%s)</option>' % (versions[0],DISTRIBS[versions[0]][1],DISTRIBS[versions[0]][0])]
        for dist in versions[1:]:
            dist_options.append('<option value="%s">%s (%s)</option>' % (dist,DISTRIBS[dist][1],DISTRIBS[dist][0]))
        return """
<h1><center>Entrez le libellé du nouveau module</h1><br>
<script LANGUAGE="JavaScript"><!--
function validfields(form)
{
    //getting the values:
    if (form.module.value.length > 40)
    {
        alert("libelle : 40 caractères maximum !");
        form.module.focus();
        return false;
    }
    else
    {
        return true;
    }
}
//--></script>
<FORM METHOD=POST ACTION="add2" onSubmit="return validfields(this)">
<table cellpadding="15" cellspacing="0" align="center" valign="middle" >
<tr><td> MODULE :</td><td>
<input type=text size=15 name="module" value=""></td></tr>
<tr><td>Version</td><td><select name="version">
%s
</select></td></tr>
<tr><td><INPUT name="submit" type=SUBMIT value="OK"></td>
<td><input name="initialiser" value="INITIALISER" type="reset" />
</td></tr>
<tr><td colspan="2"><a href="/module">Retour au menu des modules</a></td></tr>
</table>
</form>
""" % '\n'.join(dist_options)

class AddModule2(Design):
    """Ajout d'un module **page 2**
    """
    isLeaf = True

    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "add2" :
            return self
        return Module()

    def wmfactory_title(self,request):
        return "(%s) Nouveau Module - Insertion" % request.getUser()

    def wmfactory_content(self, request):
        return self.content

    def renderView(self, request):
        try:
            try:
                module = escape(request.args['module'][0])
                version = int(escape(request.args['version'][0]))
                assert module
                assert version
            except:
                raise FrontendError
            # insertion du module dans la base
            try:
                id = backend(proxy(request).modules.add_module(u(module), version))
                self.content = """<p>Le module <b>%s</b> a bien été inséré<br>
                avec la clef : <b>%s</b><br/>
                <a href="addvar?id=%s">Ajouter une variante</a><br/>
                <a href="/services/add?id=%s">Ajouter un service</a><br/>
                <a href="/module">Retour au menu des modules</a>
                </p>""" % (module, id, id, id)

            except xmlrpclib.ProtocolError:
                raise BackendError("""Vous n'êtes pas autorisé à effectuer cette action""")
            except :
                raise BackendError

        except (FrontendError,BackendError),e:
            self.content = e 
            
        return self.content


class Module(Design):
    """Page d'acceuil du conteneur module,
    et Récupération de la liste des modules
    """
    def getChild(self, name, request):

        entites = {
             'add':AddModule()
            ,'add2':AddModule2()
            # ,'get':GetModule()
            ,'edit':EditModuleDesc()
            ,'edit2':EditModuleIns()
            ,'edit_dico':EditDico()
            ,'edit_fichier':EditFichier()
            ,'save_file':SaveFile()
            ,'save_perms':SavePerms()
            ,'del_perms':DeletePerms()
            ,'majdico':MajDico()
            ,'del':DelModule()
            ,'deleted':DeletedModule()
            ,'addvar':AddVarianteDesc()
            ,'addvar2':AddVarianteIns()
            ,'getvar':GetVariante()
            ,'delvar':DelVariante()
            ,'deletedvar':DeletedVariante()
            ,'editvar':EditVarianteDesc()
            ,'editvar2':EditVarianteIns()
            ,'importvar':ImportVarianteDesc()
            ,'importvar2':ImportVarianteIns()
            ,'rapport':RapportModule()
            ,'rapport_var':RapportVariante()
            }

        if static.isDangerous(name):
            return static.dangerousPathError
        if name in entites.keys():
            return entites[name]
        return self

    def wmfactory_title(self,request):
        return "(%s) Liste des Modules" % request.getUser()

    def wmfactory_content(self, request):
        return self.content

    def wmfactory_menu(self, request):
        return Navigation(aide="page3.html").menu()
   
    def _dump_html(self,liste):
        """
        Affichage de la liste des modules
        """
        s = """<table cellpadding="1" cellspacing="2" border="1">
        <tr><td align="center">libellé</td>
        <td align="center">clef</td>
        <td colspan=3></td></tr>"""
        current = ''
        for d in liste:
            d['version'] = "Eole-%s (%s)" % (DISTRIBS[d['version']][1], DISTRIBS[d['version']][0])
            if d['version'] != current:
                current = d['version']
                s+="""<tr><td colspan='5' align='center'>
                      <font color='blue'>%s</font></td></tr>""" % current
            s += """
            <tr>
            <td>%(libelle)s</td>
            <!-- <td>%(version)s</td> -->
            <td>%(id)s</td>
            <td><a href="/module/edit?id=%(id)s">modifier</a></td>
            <td><a href="/module/del?id=%(id)s">supprimer</a></td>
            <td><a href="/module/getvar?id=%(id)s">variantes</a></td>
            <!-- <td><a href="/services/get?id=%(id)s">services</a></td> -->
            </tr>
            """ % d

        s += """</table>
        <p><FORM METHOD="POST" ACTION="/module/add">
        <input type="submit" value="Ajouter un module"></form><br/><br/>
        <a href="/module/rapport"><img src="/images/pdf.jpg"></a><br/>
        </p>
        """
        # <p><a href="/module/add">Ajouter un module</a><br/><br/>
        return s

    def renderView(self, request):
        try:
            try:
                liste = backend(proxy(request).modules.get_module())
                self.content = """<h1>Liste des modules :</h1>%s""" % self._dump_html(liste)
            except xmlrpclib.ProtocolError:
                raise BackendError("""Vous n'êtes pas autorisé à effectuer cette action""")
            except :
                raise BackendError

        except (FrontendError,BackendError),e:
            self.content = e
            
        return self.content

class RapportModule(Design):
    """Liste des modules en pdf
    """
    isLeaf = True

    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "rapport" :
            return self
        return Module()

    def wmfactory_title(self,request):
        return "(%s) Rapport Module" % request.getUser()

    def wmfactory_content(self, request):
        return self.content

    def renderView(self, request):
        try:
            try:
                nom_pdf = rapport.Rapport(proxy(request)).pdf("modules")
                self.content = """
                <p>
                <a href="%s">Télécharger le rapport en pdf</a><br/>
                <a href="javascript:history.back()">Retour</a><br/>
                </p>
                """ % nom_pdf
            except xmlrpclib.ProtocolError:
                raise BackendError("""Vous n'êtes pas autorisé à effectuer cette action""")
            except:
                raise BackendError
        except (FrontendError, BackendError), e:
            self.content = e 
        return self.content

class EditModuleDesc(Design):
    """Edition (modification) d'un module : formulaire de saisie
    """
    isLeaf = True

    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "edit" :
            return self
        return Module()

    def wmfactory_title(self,request):
        return "(%s) Module - Edition" % request.getUser()

    def wmfactory_menu(self, request):
        return Navigation(aide="page3.html").menu()
    
    def wmfactory_content(self, request):
        return self.content

    def _dump_html(self,id,libelle,dicos):
        """Formulaire d'edition du module
        """
        # formulaire de suppression des dictionnaires
        if dicos == []:
            dic_form = ""
        else:
            dic_form = """<tr><td colspan="2" align="center"><HR></td></tr>
            <tr><td><FORM METHOD=POST ACTION="/module/edit">Dictionnaires<br>existants</td>
            <td align="right"><INPUT type="hidden" name="id" value="%s">""" % id
            for dico in dicos:
                dic_form += """%s<INPUT TYPE="checkbox" NAME="del_%s"><br>""" % (dico, os.path.splitext(dico)[0])
            dic_form += """<INPUT type="SUBMIT" value="Supprimer la sélection"></td></tr></FORM>"""
        return """
<h1>Modification des données du module</h1>
<table cellpadding="6" cellspacing="0" align="center" valign="middle" >
<tr><td colspan="2" align="center"><a href="/module/get">Retour à la liste des modules</a></td></tr>
<FORM METHOD=POST ACTION="edit_dico">
<input type="hidden" name="id_module" value="%s">
<tr><td colspan="2" align="center"><INPUT type="SUBMIT" value="Changer les valeurs par défaut"></td></tr>
</form>
%s
<script LANGUAGE="JavaScript"><!--
function validfields(form)
{
    //getting dictionnary file name
    var val_dico = document.file_form.dictionnaire.value;
    document.file_form.dico_name.value = val_dico;
    //getting the values:
    if (form.libelle.value.length > 40)
    {
        alert("libelle : 40 caractères maximum !");
        form.libelle.focus();
        return false;
    }
    else
    {
        return true;
    }
}
//--></script>
<tr><td colspan="2" align="center"><HR>
<FORM METHOD=POST ACTION="edit2" name="file_form" enctype="multipart/form-data" onSubmit="return validfields(this)"></td></tr>
<tr><td>Libellé</td><td>
<input type=text size=20 name="libelle" value="%s">
<input type="hidden" name="id" value="%s">
</td></tr>
<tr><td>Dictionnaire</td>
<td colspan="2" align="center"><INPUT NAME="dictionnaire" TYPE="file"/>
<input type="hidden" name="dico_name" value=""></td></tr> 
<tr><td><INPUT type="SUBMIT" value="Mettre à jour"></td>
<td><input name="initialiser" value="INITIALISER" type="reset" /></td></tr>
</form>
</table>
""" % (id,dic_form,libelle,id)


    def renderView(self, request):
        try:
            try:
                id_mod = escape(request.args['id'][0])
                assert id_mod
            except:
                raise FrontendError("identifiant")
            # supression de dictionnaires si demandé
            mod = backend(proxy(request).modules.get_module(id_mod))[0]
            for param in request.args:
                if param.startswith('del_'):
                    dico_name = param[param.index('_')+1:]+'.xml'
                    backend(proxy(request).modules.del_mod_dict(int(id_mod),dico_name))
            try:
                resultat = backend(proxy(request).modules.get_module(int(id_mod)))
                module = resultat[0]
                # récupération des dictionnaires si creole2
                dicos = backend(proxy(request).modules.get_mod_dict(int(id_mod)))
                self.content = self._dump_html(module['id'],module['libelle'],dicos)
            except xmlrpclib.ProtocolError:
                raise BackendError("""Vous n'êtes pas autorisé à effectuer cette action""")
            except:
                raise BackendError

        except (FrontendError, BackendError), e:
            self.content = e 
            
        return self.content



class EditModuleIns(Design):
    """Edition d'un module - message au backend
    """
    isLeaf = True

    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "edit2" :
            return self
        return Module()

    def wmfactory_title(self,request):
        return "(%s) Module - Edition" % request.getUser()

    def wmfactory_content(self, request):
        return self.content


    def renderView(self, request):
        try:
            try:
                id = escape(request.args['id'][0])
                libelle = escape(request.args['libelle'][0])
                dico = request.args['dictionnaire'][0]
                dico_name = request.args['dico_name'][0]
                assert id and libelle
            except:
                raise FrontendError("identifiant ou libellé")

            try:
                mod = backend(proxy(request).modules.get_module(id))[0]
                if libelle != mod['libelle']:
                    resultat = backend(proxy(request).modules.edit_module(id,u({'libelle':libelle})))
                if dico.strip() != "":
                    if mod['version'] == 1:
                        resultat = backend(proxy(request).uucp.install_module(id,base64.encodestring(dico)))
                    else:
                        dico_name = os.path.basename(dico_name)
                        resultat = backend(proxy(request).uucp.install_module(id,{dico_name:base64.encodestring(dico)}))
                self.content = """
                <p>Le module a bien été modifié<br/>
                <a href="/module/edit?id=%s">Retour à l'édition</a><br/>
                <a href="/module">Retour au menu des modules</a>
                </p>
                """ % id

            except xmlrpclib.ProtocolError:
                raise BackendError("""Vous n'êtes pas autorisé à effectuer cette action""")
            except :
                raise BackendError

        except (FrontendError,BackendError),e:
            self.content = e
            
        return self.content

class DelModule(Design):
    """Confirmation de suppression d'un module
    """
    isLeaf = True

    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "del" :
            return self
        return Module()

    def wmfactory_title(self,request):
        return "(%s) Module (Suppression)" % request.getUser()

    def wmfactory_content(self, request):
        return self.content

    def renderView(self, request):
        try:
            try:
                id = escape(request.args['id'][0])
                assert id
            except:
                raise FrontendError("identifiant")

            self.content = """
            <p>Voulez-vous vraiment supprimer le module %s ?<br/>
            <a href="deleted?id=%s">SUPPRESSION</a><br/>
            <a href="/module">annuler</a>
            </p>
            """ % (id,id)

        except Exception, e:
            self.content = e
            
        return self.content


class DeletedModule(Design):
    """Suppression effective d'un module
    """
    isLeaf = True

    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "deleted" :
            return self
        return Module()

    def wmfactory_title(self,request):
        return "(%s) Module - Suppression" % request.getUser()

    def wmfactory_content(self, request):
        return self.content

    def renderView(self, request):
        try:
            try:
                id = escape(request.args['id'][0])
                assert id
            except:
                raise FrontendError("identifiant")
            # suppression du module de la base
            try:
                backend(proxy(request).modules.del_module(int(id)))
                self.content = """
                <p>Le module %s a bien été supprimé<br/></p>
                <a href="/module/get">Liste des modules</a><br/>
                """ % id
            except xmlrpclib.ProtocolError:
                self.content = """Vous n'êtes pas autorisé à effectuer cette action"""
            except DatabaseError, e:
                raise BackendError("Veuillez vérifier si le module que vous voulez supprimer n'est pas en cours d'utilisation.<br/>" + str(e))
            except :
                raise BackendError

        except Exception, e:
            self.content = e
            
        return self.content


class AddVarianteDesc(Design):
    """Formulaire de renseignements sur la variante
    """
    isLeaf = True

    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "addvar":
            return self
        return Module()
        
    def wmfactory_title(self,request):
        return "(%s) Nouvelle variante" % request.getUser()

    def wmfactory_content(self, request):
        return self.content

    def wmfactory_menu(self, request):
        return Navigation(aide="page3.html#section3").menu()
    
    def _dump_html(self, id) :
        return """
<h1>Entrez le libellé de la variante</h1><br/>
<script LANGUAGE="JavaScript"><!--
function validfields(form)
{
    //getting the values:
    if (form.libelle.value.length > 40)
    {
        alert("libelle : 40 caractères maximum !");
        form.libelle.focus();
        return false;
    }
    else
    {
        return true;
    }
}
//--></script>
<FORM METHOD=POST ACTION="addvar2" onSubmit="return validfields(this)">
<table cellpadding="15" cellspacing="0" align="center" valign="middle" >
<tr><td>Libellé</td><td>
<input type="text" size="20" name="libelle" value=""></td></tr>
<tr><td>Mot de passe</td>
<td><input type="password" size="20" name="pass_var" value=""></td></tr>
<tr><td>Id de la variante source (copie)</td>
<td><input type="text" size="4" name="var_src" value=""></td></tr>
<tr><td>
<input type="hidden" name="module" value="%s">
<INPUT type=SUBMIT value="OK">
</td>
<td><input name="initialiser" value="INITIALISER" type="reset" /></td>
</tr>
<tr><td colspan="2"><a href="/module/getvar?id=%s">Retour au menu des variantes</a></td></tr>
</tr>
</table>
</form>

""" % (id, id)

    def renderView(self, request):
        try:
            self.id = escape(request.args['id'][0])
            if self.id :
                self.content = self._dump_html(self.id)
            else:
                 self.content = """
            <p>vous n'avez pas renseigné l'identifiant du module<br/>
            <a href="javascript:history.back()">retour</a></p>
            """
        except Exception,e:
            self.content = e
            
        return self.content


class AddVarianteIns(Design):
    """Ajout de la variante 
    """
    isLeaf = True

    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "addvar2":
            return self
        return Module()
        
    def wmfactory_title(self,request):
        return "(%s) Nouvelle variante" % request.getUser()

    def wmfactory_content(self, request):
        return self.content


    def renderView(self, request):
        try:
            try:
                var_src = ""
                self.libelle = escape(request.args['libelle'][0])
                self.pass_var = md5.md5(escape(request.args['pass_var'][0])).hexdigest()
                self.module = escape(request.args['module'][0])
                assert self.libelle and self.module
            except:
                raise FrontendError("libellé ou mot de passe")
            else:
                # on regarde si il faut faire une copie de variante
                try:
                    var_src = escape(request.args['var_src'][0])
                    assert var_src
                except:
                    pass
                else:
                    try:
                        var_src = int(var_src)
                    except:
                        raise TypeError("l'identifiant de variante source doit être un entier")
            try:
                if var_src != "":
                    id_var = backend(proxy(request).modules.copy_variante(int(self.module),var_src,u(self.libelle),u(self.pass_var)))
                    self.content = """
                    <p><center>La variante <b>%s</b> a bien été ajoutée avec la clef %s<br/>
                    Le contenu de la variante %s a été importé avec succès<br/>
                    <a href="/module/getvar?id=%s">Retour au menu des variantes</a></center></p>
                    """ % (self.libelle,id_var,var_src,self.module)
                else:
                    id_var = backend(proxy(request).modules.add_variante(int(self.module), u(self.libelle),u(self.pass_var)))
                    self.content = """
                    <p>La variante <b>%s</b> a bien été ajoutée avec la clef %s<br/>
                    <a href="/module/getvar?id=%s">Retour au menu des variantes</a></p>
                    """ % (self.libelle,id_var,self.module)

            except xmlrpclib.ProtocolError:
                raise BackendError("""Vous n'êtes pas autorisé à effectuer cette action""")
            except:
                raise BackendError()

        except Exception, e:
            self.content = e
        return self.content

class GetVariante(Design):
    """Récupération de la liste des variantes pour un module
    """
    isLeaf = True

    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "getvar" :
            return self
        return Module()

    def wmfactory_title(self,request):
        return "(%s) Liste des variantes" % request.getUser()

    def wmfactory_content(self, request):
        return self.content

    def wmfactory_menu(self, request):
        return Navigation(aide="page3.html#section3").menu()
    
    def _dump_html(self,liste):
        """Affichage de la liste des variantes
        """
        s = """<table cellpadding="1" cellspacing="2" border="1"><tr><td align="center">libellé</td><td align="center">clef</td></tr>"""
        for d in liste:
            # on interdit la modification de la variante standard
            if d['libelle'] == 'standard':
                modele ="""<tr><td>%(libelle)s</td><td>%(id)s</td>
                <td colspan="3" align="center"><i>non modifiable</i></td></tr>""" % d
            else:
                modele = """
                <tr><td>%(libelle)s</td><td>%(id)s</td>
                <td><a href="editvar?id=%(id)s&module=%(module)s">modifier</a></td>
                <td><a href="delvar?id=%(id)s&module=%(module)s">supprimer</a></td>
                <td><a href="importvar?id=%(id)s&module=%(module)s">importer</a></td></tr>
                """ % d
            s += modele

        s += """</table>
        """ % d
        return s

    def renderView(self, request):
        try:
            try:
                # identifiant du module
                id = escape(request.args['id'][0])
                assert id
                id = int(id)
            except Exception:
                raise FrontendError("identifiant")
            
            try:
                liste_backend = backend(proxy(request).modules.get_variante())
                # filtrage : les variantes du module
                liste = []
                for d in liste_backend:
                    if d['module'] == id:
                        liste.append(d)
                try:
                    # la liste est vide
                    # normalement, ça n'arrive JAMAIS
                    self.content = """
                    <p>Ce module ne contient pas encore de variante.<br/>
                    <p><a href="addvar?id=%s">Ajouter une variante</a><br/>
                    <a href="/module">Retour au menu des modules</a></p>
                    """ % id
                    assert not liste
                except:
                    # récupération du libelle du module
                    mod = backend(proxy(request).modules.get_module(id))
                    libelle_module = mod[0]['libelle']
                    self.content = """<p>Liste des variantes relatives au module %s :
                    <br/></p>%s
                    <p><a href="addvar?id=%s">Ajouter une variante</a><br/>
                    <a href="rapport_var?module=%s"><img src="/images/pdf.jpg"></a><br/>
                    <a href="/module">retour &agrave la liste des modules</a><br>
                    </p>
                    """ % (libelle_module,self._dump_html(liste),id,id)

            except xmlrpclib.ProtocolError:
                raise BackendError("""Vous n'êtes pas autorisé à effectuer cette action""")
            except:
                raise BackendError
            
        except Exception, e:
            self.content = e
            
        return self.content

class RapportVariante(Design):
    """Liste des variantes d'un module en pdf
    """
    isLeaf = True

    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "rapport_var" :
            return self
        return Module()

    def wmfactory_title(self,request):
        return "(%s) Rapport variantes" % request.getUser()

    def wmfactory_content(self, request):
        return self.content

    def renderView(self, request):
        try:
            try:
                self.module = escape(request.args['module'][0])
                assert not self.module == ""
            except Exception:
                raise FrontendError("identifiant du module")
            try:
                nom_pdf = rapport.Rapport(proxy(request)).pdf('variante_module',self.module)
                self.content = """<p>
                <a href="%s">Télécharger le rapport en pdf</a><br/>
                <a href="javascript:history.back()">Retour</a><br/>
                </p>""" % nom_pdf
            except xmlrpclib.ProtocolError:
                raise BackendError("""Vous n'êtes pas autorisé à effectuer cette action""")
            except:
                raise BackendError
        except (FrontendError, BackendError), e:
            self.content = e 
        return self.content

class DelVariante(Design):
    """Confirme la suppression d'une variante
    """
    isLeaf = True

    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "delvar" :
            return self
        return Module()

    def wmfactory_title(self,request):
        return "(%s) Variante - Suppression" % request.getUser()

    def wmfactory_content(self, request):
        return self.content

    def renderView(self, request):
        try:
            try:
                id = escape(request.args['id'][0])
                id_module = escape(request.args['module'][0])
            except:
                raise FrontendError("identifiant")

            self.content = """
            <p>Voulez-vous vraiment supprimer la variante %s ?<br/>
            <a href="deletedvar?id=%s&module=%s">SUPPRESSION</a><br/>
            <a href="/module/getvar?id=%s">annuler</a></p>
            """ % (id,id,id_module,id_module)

        except Exception, e:
            self.content = e
            
        return self.content


class DeletedVariante(Design):
    """Suppression effective d'une variante
    """
    isLeaf = True

    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "deletedvar" :
            return self
        return Module()

    def wmfactory_title(self,request):
        return "(%s) Variante (Suppression)" % request.getUser()

    def wmfactory_content(self, request):
        return self.content

    def renderView(self, request):
        try:
            try:
                id = escape(request.args['id'][0])
                id_module = escape(request.args['module'][0])
            except:
                raise FrontendError("identifiant")

            try:
                backend(proxy(request).modules.del_variante(int(id)))
            except xmlrpclib.ProtocolError:
                raise BackendError("""Vous n'êtes pas autorisé à effectuer cette action""")
            except DatabaseError, e:
                raise BackendError("Veuillez vérifier si la variante à supprimer n'est pas en cours d'utilisation.<BR>")
            except Exception, e:
                raise BackendError
            
            self.content = """
            <p>La variante a bien été supprimée<br/></p>
            <a href="/module/getvar?id=%s">Retour à la liste des variantes</a><br/>
            """ % id_module


        except Exception, e:
            self.content = e
            

        return self.content

    

class EditVarianteDesc(Design):
    """Edition d'une variante (formulaire de saisie)
    """
    isLeaf = True

    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "editvar" :
            return self
        return Module()

    def wmfactory_title(self,request):
        return "(%s) Variante - Edition" % request.getUser()

    def wmfactory_content(self, request):
        return self.content

    def wmfactory_menu(self, request):
        return Navigation(aide="howto/page6.html#section3").menu()
    
    def _dump_html(self,id_var,id_module,libelle,fichiers,user_ok=False):
        """Formulaire d'edition 
        """
        #constitution de l'affichage des fichiers (plus lien de suppression)
        if user_ok == False:
            pass_form = """<br/><FORM name="passform" onSubmit="return false;">Mot de passe <input type="password" name="passwd" value=""/>(si variante créée par un autre utilisateur)</FORM><br/>"""
        else:
            pass_form = """<FORM name="passform" onSubmit="return false;"><input type="hidden" name="passwd" value=""/></FORM>"""

        affiche={}
        for type_f in ['dicos_var','persos_var','patchs_var','fichiers_var','rpms_var']:
            l=["""<table width="100%">"""]
            liste_fichiers = fichiers[type_f]
            # tri des fichiers
            liste_fichiers.sort(key=lambda x:x[0])
            for f in liste_fichiers:
                if type_f != 'rpms_var':
                    if type_f == 'fichiers_var':
                        # cas particulier des fichiers persos : icone selon le type et la présence ou non
                        f, f_info = f
                        f_img = file_icons.get(f_info,'gnome-mime-text.png')
                        if f_info == 'missing':
                            # fichier non présent sur zephir
                            l.append("""<tr><td><img src="/images/%s">%s</td><td align="right">(<a href="javascript:del_file('%s','%s')">supprimer</a>)</td></tr>""" % (f_img, f, f,type_f))
                        else:
                            l.append("""<tr><td><img src="/images/%s"><a href="edit_fichier?id=%s&module=%s&file=%s&type=%s">%s</a></td><td align="right">(<a href="javascript:del_file('%s','%s')">supprimer</a>)</td></tr>""" % (f_img,id_var,id_module,f,type_f,f,f,type_f))
                    else:
                        l.append("""<tr><td><a href="edit_fichier?id=%s&module=%s&file=%s&type=%s">""" % (id_var,id_module,f,type_f) + f + """</a></td><td align="right">(<a href="javascript:del_file('%s','%s')">supprimer</a>)</td></tr>""" % (f,type_f))
                else:
                    l.append("<tr><td>"+f+"""</td><td align="right"><a href="editvar?id=%s&module=%s&fic_sup=%s&type=%s">supprimer</a></td></tr>""" % (id_var,id_module,f,type_f))
            l.append("</table>")
            affiche[type_f]=l
        return """
<h1>description de la variante</h1>
<table><tr><td><FORM METHOD=POST ACTION="edit_dico">
<input type="hidden" name="id_module" value="%s">
<input type="hidden" name="id_variante" value="%s">
<center><INPUT type="SUBMIT" value="Changer les valeurs par défaut"/></center>
</form></td><td>
<FORM METHOD=POST ACTION="/module/del_perms">
<input type="hidden" name="module" value="%s">
<input type="hidden" name="id" value="%s">
<center><INPUT type="SUBMIT" value="Voir les permissions définies"/></center>
</form></td></tr></table>
%s
<FORM METHOD="POST" NAME="delform" ACTION="/module/editvar">
<INPUT TYPE="hidden" NAME="id" VALUE="%s">
<INPUT TYPE="hidden" NAME="module" VALUE="%s">
<INPUT TYPE="hidden" NAME="fic_sup" VALUE="">
<INPUT TYPE="hidden" NAME="type" VALUE="">
<INPUT TYPE="hidden" NAME="pass_var" VALUE="">
</FORM>
<table border="1" cellpadding="5" cellspacing="0" align="center" valign="middle" >
<script LANGUAGE="JavaScript"><!--
function del_file(fic,type_fic)
{
    var del_form = document.forms['delform'];
    del_form.fic_sup.value = fic;
    del_form.type.value = type_fic;
    // hack : on force le focus pour valider le champ passwd au cas où on serait encore dedans
    document.forms['libel_form'].libelle.focus();
    var pass_var = document.forms['passform'].passwd.value;
    if ((pass_var != "") && (pass_var != null))
    {
        del_form.pass_var.value = pass_var;
    }
    del_form.submit()
    return location;
}
function validfields(form)
{
    // fetching password
    form.pass_var.value = document.forms['passform'].passwd.value;
    //getting the values:
    if (form.libelle.value.length > 40)
    {
        alert("libelle : 40 caractères maximum !");
        form.libelle.focus();
        return false;
    }
    else
    {
        return true;
    }
}
//--></script>
<FORM METHOD="POST" NAME="libel_form" "ACTION="editvar2" onSubmit="return validfields(this)">
<input type="hidden" name="id" value="%s">
<input type="hidden" name="module" value="%s">
<tr><td>Libellé<br/><input type=text size=20 name="libelle" value="%s"></td><td><input type="hidden" name="pass_var" value=""/><br/><input type="submit" value="Changer le libellé"/></td></tr></form>

<script language="JavaScript"><!--
function get_names ()
{
    //getting the values:
    var val_pass = document.forms['passform'].passwd.value;
    var val_dico = document.file_form.dico.value;
    var val_template = document.file_form.template.value;
    var val_patch = document.file_form.patch.value;
    //setting the values:
    document.file_form.pass_var.value = val_pass;
    document.file_form.dico_name.value = val_dico;
    document.file_form.template_name.value = val_template;
    document.file_form.patch_name.value = val_patch;
}
//--></script>

<FORM name="file_form" METHOD="POST" ACTION="editvar" enctype="multipart/form-data" onSubmit="javascript:get_names()">
<tr><td align="center" colspan="2">Liste des fichiers</td></tr>
<tr><td valign="top">Dictionnaires additionnels<br/><INPUT NAME="dico" TYPE="file"/></td><td>%s</td>
<tr><td valign="top">Templates additionnels<br/><INPUT NAME="template" TYPE="file"/></td><td>%s</td>
<tr><td valign="top">Patchs<br/><INPUT NAME="patch" TYPE="file"/></td><td>%s</td>
<tr><td valign="top">Fichiers divers<br/><INPUT NAME="fichier" TYPE="file"/><br><input type="text" name="fichier_name" value="">destination</td><td>%s</td></tr>
<tr><td valign="top">Paquets additionnels<br/><INPUT NAME="rpms" TYPE="text"/></td><td>%s</td>
<input type="hidden" name="dico_name" value="">
<input type="hidden" name="template_name" value="">
<input type="hidden" name="patch_name" value="">
<tr><td><input type="hidden" name="id" value="%s">
<input type="hidden" name="module" value="%s">
<input type="hidden" name="fichiers" value="oui">
<input type="hidden" name="pass_var" value=""/></td>
<td><center><INPUT type=SUBMIT value="ajouter les fichiers"><br>
<input name="initialiser" value="REINITIALISER" type="reset"/></center></td></tr>
</form>
</table><p>
<a href="/module/getvar?id=%s">Retour au menu des variantes</a></p>
<a href="/module/get">Retour à la liste des modules</a><br>
""" % (id_module,id_var,id_module,id_var,pass_form,id_var,id_module,id_var,id_module,libelle,"".join(affiche['dicos_var']),"".join(affiche['persos_var']),"".join(affiche['patchs_var']),"".join(affiche['fichiers_var']),"".join(affiche['rpms_var']),id_var,id_module,id_module)


    def renderView(self, request):
        try:
            try:
                id_var = escape(request.args['id'][0])
                id_module = escape(request.args['module'][0])
            except:
                raise FrontendError("identifiant")
            # mot de passe de la variante en paramètre ?
            try:
                pass_var = md5.md5(escape(request.args['pass_var'][0])).hexdigest()
            except:
                pass_var = None
            # on regarde si on doit supprimer un fichier
            try:
                fic_sup=escape(request.args['fic_sup'][0])
                type_sup=escape(request.args['type'][0])
            except:
                # on regarde si on doit ajouter des fichiers
                try:
                    request.args['fichiers'][0]
                except:
                    # on arrive depuis une autre page
                    pass
                else:
                    # on a demandé un ajout de fichiers
                    dic_files = {'dicos_var':[],'patchs_var':[],'persos_var':[],'fichiers_var':[],'rpms_var':[]}
                    # on récupère les noms et contenus des fichiers
                    try:
                        dic_files['dicos_var'].append([escape(request.args['dico_name'][0]),base64.encodestring(request.args['dico'][0])])
                    except:
                        pass
                    try:
                        dic_files['persos_var'].append([escape(request.args['template_name'][0]),base64.encodestring(request.args['template'][0])])
                    except:
                        pass
                    try:
                        dic_files['patchs_var'].append([escape(request.args['patch_name'][0]),base64.encodestring(request.args['patch'][0])])
                    except:
                        pass
                    try:
                        dic_files['fichiers_var'].append([escape(request.args['fichier_name'][0]),base64.encodestring(request.args['fichier'][0])])
                    except:
                        pass
                    else:
                        # il faut donner un chemin absolu
                        if escape(request.args['fichier_name'][0]) != '' and not escape(request.args['fichier_name'][0]).startswith('/'):
                            raise Exception("""le chemin du fichier doit être absolu (ex : /tmp/toto)<p><a href="javascript:history.back()">retour</a></p>""")
                    try:
                        dic_files['rpms_var'].append(escape(request.args['rpms'][0]))
                    except:
                        pass
                    # mise en place des fichier
                    if pass_var is not None:
                        backend(proxy(request).modules.add_files(int(id_var),dic_files,u(pass_var)))
                    else:
                        backend(proxy(request).modules.add_files(int(id_var),dic_files))
            else:
                # on demande la suppression du fichier
                dic_files = {'dicos_var':[],'patchs_var':[],'persos_var':[],'fichiers_var':[],'rpms_var':[]}
                dic_files[type_sup].append(fic_sup)
                # on supprime
                if pass_var is not None:
                    backend(proxy(request).modules.del_files(int(id_var),dic_files,u(pass_var)))
                else:
                    backend(proxy(request).modules.del_files(int(id_var),dic_files))
            try:
                dico_fic = backend(proxy(request).modules.fichiers_variante(int(id_var),True))
                resultat = backend(proxy(request).modules.get_variante(int(id_var)))
                d = resultat[0]
            except xmlrpclib.ProtocolError:
                self.content = """Vous n'êtes pas autorisé à effectuer cette action"""
            try:
                if d['owner'] == request.getUser():
                    user_ok = True
                else:
                    user_ok = False
                self.content = self._dump_html(d['id'],id_module,d['libelle'],dico_fic,user_ok)
            except Exception,e:
                raise FrontendError(e)
        except Exception,e :
            self.content = str(e)

        return self.content

class EditVarianteIns(Design):
    """Edition d'une variante (message au backend)
    """
    isLeaf = True

    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "editvar2" :
            return self
        return Module()

    def wmfactory_title(self,request):
        return "(%s) Variante - Edition" % request.getUser()

    def wmfactory_content(self, request):
        return self.content


    def renderView(self, request):
        try:
            try:
                id = escape(request.args['id'][0])
                id_module = escape(request.args['module'][0])
                libelle = escape(request.args['libelle'][0])
            except:
                raise FrontendError("identifiant ou libelle")

            try:
                backend(proxy(request).modules.edit_variante(int(id),u({'libelle':libelle})))
                self.content = """
                <p>La variante %s a bien été modifiée<br/>
                <a href="/module/getvar?id=%s">Retour au menu des variantes</a>
                </p>
                """ % (libelle, id_module)
            except xmlrpclib.ProtocolError:
                raise BackendError("""Vous n'êtes pas autorisé à effectuer cette action""")
            except Exception, e:
                raise BackendError()

        except Exception, e:
            self.content = e
            
        return self.content


class ImportVarianteDesc(Design):
    """Import d'une variante distante (formulaire de saisie)
    """
    isLeaf = True

    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "importvar" :
            return self
        return Module()

    def wmfactory_title(self,request):
        return "(%s) Variante - Import" % request.getUser()

    def wmfactory_content(self, request):
        return self.content

    def _dump_html(self,id_var,id_module,owner,cred_user):
        """Formulaire d'edition 
        """
        l=["""<h1>Paramètres d'import</h1>
<FORM METHOD="POST" ACTION="importvar2">
<input type="hidden" name="module" value="%s">
<input type="hidden" name="id" value="%s">""" %  (id_module,id_var)]

        if owner != cred_user:
            l.append("""mot de passe de la variante&nbsp;<input type="password" name="passwd" value=""/><br>
(cette variante à été créée par %s)<br>""" % owner)
        else:
            l.append("""<input type="hidden" name="passwd" value="">""")
            
        l.append("""<table border="1">
<tr><td><input type="text" name="adr_zephir" value=""/></td><td>adresse zephir distant</td></tr>
<tr><td><input type="text" name="login_distant" value=""/></td><td>utilisateur sur zephir distant</td></tr>
<tr><td><input type="password" name="pwd_distant" value=""/></td><td>(mot de passe correspondant)</td></tr>
<tr colspan="3"><br></tr>
<tr><td><input type="text" name="id_distant" value=""/></td><td>n° de variante à copier</td></tr></table>
<p><center><INPUT type=SUBMIT value="Importer">
<input name="initialiser" value="REINITIALISER" type="reset"/></center></p>
</form>

<a href="/module/getvar?id=%s">Retour au menu des variantes</a><br>
<a href="/module/get">Retour à la liste des modules</a></p>
""" % (id_module))

        return "".join(l)

    def renderView(self, request):
        try:
            try:
                id_var = escape(request.args['id'][0])
                id_module = escape(request.args['module'][0])
            except:
                raise FrontendError("identifiant")
            try:
                resultat = backend(proxy(request).modules.get_variante(int(id_var)))
                owner = resultat[0]['owner']
                cred_user=request.getUser()
            except xmlrpclib.ProtocolError:
                self.content = """Vous n'êtes pas autorisé à effectuer cette action"""
            try:
                pass
            except:
                raise FrontendError
            self.content = self._dump_html(id_var,id_module,owner,cred_user)
        except Exception,e :
            self.content = str(e)

        return self.content


class ImportVarianteIns(Design):
    """import réel de la variante 
    """
    isLeaf = True

    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "importvar2":
            return self
        return Module()
        
    def wmfactory_title(self,request):
        return "(%s) Confirmation d'import" % request.getUser()

    def wmfactory_content(self, request):
        return self.content

    def renderView(self, request):
        try:
            try:
                id_var = escape(request.args['id'][0])
                module = escape(request.args['module'][0])
                pass_var = escape(request.args['passwd'][0])
                adr_zephir = escape(request.args['adr_zephir'][0])
                login = escape(request.args['login_distant'][0])
                pwd = escape(request.args['pwd_distant'][0])
                id_src = escape(request.args['id_distant'][0])
                # assert id_var and module and adr_zephir and login and pwd and id_src
            except:
                raise FrontendError
            if pass_var != "":
                pass_var = md5.md5(pass_var).hexdigest()
            try:
                res = backend(proxy(request).modules.import_variante(pass_var,int(id_var),int(id_src),u(adr_zephir),u(login),u(pwd)))
            except:
                raise BackendError("""Mauvais mot de passe pour la variante locale""")
            try:
                self.content = """<p>La variante a bien été importée<br/>
                <a href="/module/getvar?id=%s">Retour au menu des variantes</a></p>
                """ % (module)
            except xmlrpclib.ProtocolError:
                raise BackendError("""Vous n'êtes pas autorisé à effectuer cette action""")
            except Exception,e:
                raise BackendError(e)

        except Exception, e:
            self.content = e
        return self.content

class EditDico(Design):
    """génération d'un formulaire de saisie de dictionnaire
    """
    isLeaf = True

    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "edit_dico" :
            return self
        return Serveur()
    
    def wmfactory_title(self,request):
        return "(%s) Valeurs par défaut du dictionnaire" % request.getUser()

    def wmfactory_content(self, request):
        return self.content

    def _dump_html(self, dico_eole, id_module, id_variante, expert, current_family, erreurs, request, id_dico):
        """Affichage de la liste des variabes du dictionnaire
        """
        # instanciation du dico
        num_var = 0
        # récupération des variables et familles à afficher
        families = dico_eole.get_menu(expert)
        if id_variante is not None:
            s = ["""<a href="editvar?id=%s&module=%s">Retour à l'édition de la variante</a><br><br>""" % (id_variante,id_module)]
        else:
            s = ["""<a href="edit?id=%s">Retour à l'édition du module</a><br><br>""" % id_module]

        # création de la liste des onglets disponibles    
        s.append("""<table cellpadding="1" cellspacing="2" border="0" width="99%%"><tr> """)
        current_vars = []
        if current_family not in [family[0] for family in families]:
            # la famille "general" n'existe pas, on prend la 1ere non cachée
            for family in families:
                if family[1] == False:
                    current_family = family[0]
                    break
        for family in families:
            if family[0] == current_family:
                current_vars = family[2]
                special_button = "disabled"
            else:
                special_button = ""
            # on n'affiche que les familles visibles
            if family[1] == False:
                s.append("""<td><FORM METHOD="POST" ACTION="/module/edit_dico">
                <input type="hidden" name="id_module" value ="%s">""" % id_module)
                if id_variante is not None:
                    s.append("""<input type="hidden" name="id_variante" value="%s">""" % id_variante)
                s.append("""<input type="hidden" name="family" value ="%s">
                <input type="hidden" name="expert" value ="%s">
                <input type="hidden" name="id_dico" value ="%s">
                <input type=SUBMIT %s value="%s"></FORM></td>""" % (family[0], expert, id_dico, special_button,  family[0]))
        s.append("""<td width="100%%"></td>""")

        if dico_eole.version != "creole1":
            s.append("""</tr></table><table cellpadding="1" cellspacing="2" border="0" width="100%%"><tr><td><FORM METHOD="POST" ACTION="/module/edit_dico">
            <input type="hidden" name="id_module" value ="%s">
            <input type="hidden" name="id_dico" value ="%s">
            <input type="hidden" name="family" value ="%s">""" % (id_module, id_dico, current_family))
            if id_variante is not None:
                s.append("""<input type="hidden" name="id_variante" value="%s">""" % id_variante)
            if expert == 0:
                s.append("""<input type="hidden" name="expert" value ="1">
                <INPUT type=SUBMIT value="Mode expert"></FORM>""")
            else:
                s.append("""<input type="hidden" name="expert" value ="0">
                <INPUT type=SUBMIT value="Mode normal"></FORM>""")

        if dico_eole.modified == True and erreurs == {}:
            s.append("""</td><td><FORM METHOD="POST" ACTION="/module/majdico">
            <input type="hidden" name="id_module" value ="%s">
            <input type="hidden" name="id_dico" value ="%s">
            <input type="hidden" name="family" value ="%s">
            <table><tr><td><input type=SUBMIT style="background-color:#22DD44;" value="Sauver sur Zephir"></td><td>""" % (id_module, id_dico, current_family))
            if id_variante is not None:
                try:
                    detail_var = backend(proxy(request).modules.get_variante(int(id_variante)))
                    var_owner = detail_var[0]['owner']
                except:
                    var_owner = ""
                if var_owner != request.getUser():
                    s.append("""Mot&nbsp;de&nbsp;passe</td><td><input type="password" name="pass_var" value=""/>""")
                else:
                    s.append("""<input type="hidden" name="pass_var" value=""/>""")
                s.append("""<input type="hidden" name="id_variante" value="%s">""" % id_variante)

            s.append("""</td></tr></table>""")
        s.append("""</FORM></td><td width="100%"></td></tr></table> """)

        s.append("""<table cellpadding="1" cellspacing="2" border="1" width="98%%">
        <FORM METHOD="POST" NAME="creole" ACTION="/module/edit_dico"> 
        <input type="hidden" name="id_module" value ="%s">
        <input type="hidden" name="id_dico" value ="%s">
        <input type="hidden" name="family" value ="%s">
        <input type="hidden" name="expert" value ="%s">""" % (id_module, id_dico, current_family, expert))
        if id_variante is not None:
            s.append("""<input type="hidden" name="id_variante" value="%s">""" % id_variante)
        s.append("""<tr><td>libelle</td><td>valeur</td><td>variable</td></tr>""")
        if dico_eole.version != "creole1":
            s.append("""<tr><td colspan="3"><font color="blue">&nbsp;* : variable multivaluée : utiliser le caractère | pour séparer les valeurs.</font></td></tr>""")
        s.append("""<script language='javascript'>
        function copy_val(liste_name,input_name) {
        inputbox = document.forms['creole'][input_name];
        liste = document.forms['creole'][liste_name];
        val = liste.options[liste.selectedIndex].value;
        if (val != '- autre -') {
            inputbox.disabled="disabled";
            inputbox.value = val;
            }
        else {
            inputbox.disabled="";
            inputbox.value = ""
        }
        }</script>""")
        last_var_invisible = False
        for var in current_vars:
            nom,valeur,libelle,invisible,obligatoire,mime = dico_eole.get_var(var)
            d=convert({'nom':nom,'libelle':libelle,'valeur':" | ".join(valeur),'num_var':num_var})
            if erreurs.has_key(nom):
                # si erreur, on réaffiche la saisie pécédente
                d['valeur'] = convert(erreurs[nom][0])
            # traitement de cas particuliers : listes de choix
            liste_choix, allow_other = dico_eole.get_enumeration(nom)
            if not invisible:
                last_var_invisible = False
                d['font_options'] = ""
                if obligatoire:
                    d['font_options'] = ' style="font-weight:bold"'
                d['multi'] = ""
                if nom in dico_eole.multivars:
                    d['multi'] = """<font color="blue">* </font>"""
                if liste_choix != []:
                    liste_choix.append('- autre -')
                    # construction de la liste de choix dans le formulaire
                    input_others = ""
                    # XXX FIXME : on propose toujours other pour gérer les variables multiples
                    # if allow_other == True:
                    # si on autorise d'autres valeurs, on met une textbox en plus
                    val_other = d['valeur']
                    if d['valeur'] not in liste_choix:
                        input_others = """<input type="text" size="13" name="var%s_other" value="%s"/>""" % (d["num_var"], val_other)
                    else:
                        input_others = """<input type="text" size="13" name="var%s_other" disabled="disabled" value="%s"/>""" % (d["num_var"], val_other)
                    l = ["""<select name="var%(num_var)s" onChange="javascript:copy_val('var%(num_var)s','var%(num_var)s_other')">""" % d]
                    for val_choix in liste_choix:
                        if d['valeur'] not in liste_choix and val_choix == '- autre -':
                            l.append("""<OPTION selected VALUE="%s">%s</OPTION>""" % (val_choix,val_choix))
                        elif val_choix == " | ".join(valeur):
                            l.append("""<OPTION selected VALUE="%s">%s</OPTION>""" % (val_choix,val_choix))
                        else:
                            l.append("""<OPTION VALUE="%s">%s</OPTION>""" % (val_choix,val_choix))
                    l.append("</select>")
                    s.append("""<tr><td><table cellspacing="0" cellpading="0" border="0" width="100%%"><tr><td><font%s>%s%s</font></td><td align="right">%s</td></tr></table></td><td>""" % (d['font_options'], d['multi'], d['libelle'], "".join(l)) + input_others + """</td><td>%(nom)s</td></tr>""" % d)
                else:
                    # FIXME : gestion des listes de valeurs (pour l'instant, séparation par des | )
                    # on regarde si une valeur a été modifiée depuis l'entrée dans le formulaire
                    d['font_options'] = ""
                    if obligatoire:
                        d['font_options'] = ' style="font-weight:bold"'
                    d['multi'] = ""
                    if nom in dico_eole.multivars:
                        d['multi'] = """<font color="blue">* </font>"""
                    s.append("""<tr><td><font%(font_options)s>%(multi)s%(libelle)s</font></td><td><input type="text" size="20" name="var%(num_var)s" value="%(valeur)s"/></td><td>%(nom)s</td></tr>""" % d)
            else:
                # variables cachées (pour rappel, on met une ligne avec '...' si la précédente n'est pas cachée)
                # s.append("""<tr><td>&nbsp;&nbsp;&nbsp;<i>%(libelle)s</i></td><td><input type="text" size="20" name="var%(num_var)s" value="%(valeur)s"/></td><td>%(nom)s</td></tr>""" % d)
                if last_var_invisible == False:
                    # cas particulier, on affiche rien pour les variables automatiques
                    if nom not in dico_eole.autovars:
                        s.append("""<tr><td colspan="3">&nbsp;...</td></tr>""")
                last_var_invisible = True
                s.append("""<input type="hidden" name="var%(num_var)s" value="%(valeur)s"/>""" % d)
            if erreurs.has_key(nom):
                s.append("""<tr><td colspan=2><font color="red"><i>%s</i></font></td><td>%s</td></tr>""" % (convert(erreurs[nom][1]), convert(nom)))
            num_var = num_var + 1


        s.append("""<td align="right"><center><input name="initialiser" value="Réinitialiser cette page" type="reset"/></center></td>""")
        s.append("""<td colspan=2><center><INPUT type=SUBMIT value="Valider les valeurs"></center></td></tr></FORM></table><br>""")

        return "\n".join(s)

    def renderView(self, request):
        try:
            try:
                id_module = escape(request.args['id_module'][0])
            except Exception:
                raise FrontendError("id module")
            try:
                # modification de dico.eol
                id_variante = escape(request.args['id_variante'][0])
            except:
                # modification de dictionnaire
                id_variante = None
            try:
                id_dico = escape(request.args['id_dico'][0])
            except:
                id_dico = ""

            data = None
            libel_variantes = self.get_variante(proxy(request))
            if id_variante is None:
                self.content = """<h1>Définition des valeurs par défaut du module</h1>"""
            else:
                self.content = """<h1>Définition des valeurs par défaut de la variante</h1>"""
            try:
                expert = escape(request.args['expert'][0])
                expert = int(expert)
            except:
                expert = 0
            try:
                current_family = escape(request.args['family'][0])
                first_access = False
            except:
                # première entrée sur le formulaire
                current_family = "general"
                first_access = True

            # dictionnaire des erreurs de validation des données
            erreurs = {}
            fin = 0
            num_var = 0
            try:
                prefs = request.getSession()
                if first_access == True:
                    if id_variante is None:
                        recup_dico = backend(proxy(request).modules.get_dico(int(id_module)))
                    else:
                        if libel_variantes[int(id_variante)] == 'standard':
                            # pas de dico.eol pour la variante standard
                            self.content = """dico.eol ne peut pas être modifié pour la variante standard"""
                            self.content += """<br><a href="javascript:history.back()">retour à la page précédente</a><br>"""
                        else:
                            recup_dico = backend(proxy(request).modules.get_dico(int(id_module),int(id_variante)))

                    if not base64.decodestring(recup_dico[0]).startswith('<?xml'):
                        # creole1
                        dic_zeph = []
                        for dico_b64 in recup_dico:
                            dico_txt=base64.decodestring(dico_b64).split('\n')
                            dico_final=[]
                            for ligne in dico_txt:
                                dico_final.append(ligne+'\n')
                            dic_zeph.append(dico_final)
                        dico_eole = ZephirDict(dicos=dic_zeph, version='creole1', mode='')
                    else:
                        # creole 2
                        dico_eole = ZephirDict(mode='')
                        dico_eole.init_from_zephir(recup_dico)
                    # on stocke le dictionnaire dans la session de l'utilisateur
                    dico_eole.modified = False
                    # on génère un identifiant de dictionnaire pour le stocker
                    id_dico = os.path.basename(tempfile.mktemp())
                    if not hasattr(prefs,'dico_eole'):
                        prefs.dico_eole = {id_dico:dico_eole}
                    else:
                        prefs.dico_eole[id_dico] = dico_eole
                else:
                    # on a déjà changé de famille ou validé des modifs : on reprend le dictionnaire dans la session
                    dico_eole = prefs.dico_eole[id_dico]
                    # si on a reçu des variables à insérer, on les valide
                    if request.args.has_key('var0'):
                        try:
                            erreurs = self.insert_values(request, current_family, dico_eole, expert)
                        except Exception, e:
                            print "erreur de validation : ", str(e)
                        
                self.content += self._dump_html(dico_eole, id_module, id_variante, expert, current_family, erreurs, request, id_dico)

            except xmlrpclib.ProtocolError:
                raise BackendError("""Vous n'êtes pas autorisé à effectuer cette action""")
            except Exception, e:
                raise BackendError(e)

        except (FrontendError,BackendError),e:
            self.content = e

        return self.content

    def insert_values(self, request, current_family, dico_eole, expert):
        """valide les données saisies et les stocke dans le dictionnaire
        """
        # on récupère la liste des variables de la famille
        families = dico_eole.get_menu(expert)
        for family in families:
            if family[0] == current_family:
                liste_vars = family[2]
        # on crée une liste de toutes les variables susceptibles d'avoir des valeurs multiples
        multi_vars = {}
        if dico_eole.version == "creole2":
            for var in liste_vars:
                if dico_eole.dico.variables[var].multi == True:
                    multi_vars[var] = None
                    # on ajoute les variables groupées si besoin
                    for slave in dico_eole.dico.groups.get(var,[]):
                        multi_vars[slave] = var
        num_var = 0
        erreurs = {}
        for var in liste_vars:
            nom,valeur,libelle,invisible,obligatoire,mime = dico_eole.get_var(var)
            # on récupère le champ du formulaire correspondant
            try:
                # si il y a un champ X_other non vide, il est prioritaire
                try:
                    saisie = escape(request.args['var'+str(num_var)+'_other'][0])
                    assert saisie != ''
                except:
                    saisie = escape(request.args['var'+str(num_var)][0])
            except KeyError:
                saisie = ""
            if dico_eole.version == "creole2":
                if nom in multi_vars:
                    vals = [data.strip() for data in saisie.split('|')]
                else:
                    vals = [saisie.strip()]
            else:
                vals = saisie
            # debug 
            # print 'var'+str(num_var)+' : '+nom+' -> '+str(vals)
            try:
                dico_eole.set_value(vals,invisible,force=True)
            except Exception, e:
                # les données entrées sont incorrectes
                #er_type, er_value, er_traceback = sys.exc_info()
                #er_msg = er_value
                erreurs[convert(nom)]=[saisie, str(e)]
            else:
                # au moins une valeur a été changée avec succès, on permet de sauvegarder
                dico_eole.modified = True
            # on passe à la variable suivante
            num_var = num_var + 1

        if dico_eole.version == "creole2":
            # vérification des variables groupées
            for slave, master in multi_vars.items():
                if master is not None:
                    nb_master = len(dico_eole.dico.get_value(master))
                    nb_slave = len(dico_eole.dico.get_value(slave))
                    if nb_master != nb_slave:
                        erreurs[convert(slave)] = [saisie, "Les variables %s et %s doivent avoir le même nombre de valeurs" \
                                % (convert(master),convert(slave))]
        return erreurs

class EditFichier(Design):
    """Edition d'un fichier de variante
    """
    isLeaf = True

    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "edit_fichier" :
            return self
        return Module()

    def wmfactory_title(self,request):
        return "(%s) Edition (fichier de variante)" % request.getUser()

    def wmfactory_content(self, request):
        return self.content

    def renderView(self, request):
        try:
            # définition du chemin du fichier en fonction de son type
            chemins={'dicos_var':'dicos/',
                    'persos_var':'fichiers_perso/',
                    'patchs_var':'patchs/',
                    'fichiers_var':'fichiers_zephir/'
            }
            try:
                filename = escape(request.args['file'][0])
                module = escape(request.args['module'][0])
                variante = escape(request.args['id'][0])
                type_file = escape(request.args['type'][0])
                assert variante
                assert module
                assert filename
                assert type_file in chemins.keys()
            except:
                raise FrontendError
            try:
                localpath=escape(request.args['localpath'][0])
            except:
                localpath = ""
            basepath=localpath
            try:
                # récupération du contenu
                if localpath != "":
                    path = localpath + os.sep + os.path.basename(filename)
                else:
                    path = chemins[type_file] + os.path.basename(filename)
                localpath = path
                contenu = backend(proxy(request).modules.get_var_file(variante,module,path,True))
                var_owner = ""
                detail_var = backend(proxy(request).modules.get_variante(int(variante)))
                var_owner = detail_var[0]['owner']
                var_mod = detail_var[0]['module']
                detail_mod = backend(proxy(request).modules.get_module(int(var_mod)))
                mod_version = int(detail_mod[0]['version'])
            except:
                raise BackendError
                
            self.content = """<br/><a href=/module/editvar?id=%s&module=%s>retour</a>""" % (variante, module)
            # gestion des droits pour les fichiers personnalisés (pas dicos et patchs)
            if (type_file  == 'persos_var') and (mod_version > 1):
                # les droits sont gérés au niveau du dictionnaire
                self.content += """<center><br/><font color="blue">Les droits à appliquer sur les templates personnalisés
                doivent être défini dans le dictionnaire correspondant</font><br/>
                exemple:&nbsp;&lt;file name='/etc/ldap/slapd.conf' owner="openldap" group="openldap" mode="0640"/&gt;"""
            elif type_file == 'fichiers_var':
                # récupération des droits actuels du fichier
                file_rights = backend(proxy(request).modules.get_variante_perms(variante, path))
                if file_rights[path] != []:
                    mode, user, group, recursive = file_rights[path]
                if recursive == True:
                    checked = " CHECKED"
                else:
                    checked = ""
                # on affiche le contenu dans une boite de saisie de texte
                self.content += """<script LANGUAGE="JavaScript"><!--
                function getpwd(form)
                {
                    //getting passwd from passwd field
                    form.pass_var.value = document.forms['passform'].passwd.value;
                    return true;
                }
                //--></script>"""
                # formulaire de modification des droits/utilisateurs
                if type(contenu) == list:
                    recurse_label = "<td>recursif</td>"
                    recurse_input = """<td align="center"><INPUT TYPE="checkbox" NAME="recurse"%s></td>""" % checked
                else:
                    recurse_label = recurse_input = ""
                # boite de saisie du mot de passe commune aux deux formulaires
                self.content += """<table border="1">
                <FORM METHOD="POST" ACTION="save_perms" onSubmit="return getpwd(this)">
                <INPUT TYPE="hidden" NAME="filename" value="%s">
                <INPUT TYPE="hidden" NAME="id" value="%s">
                <INPUT TYPE="hidden" NAME="module" value="%s">
                <tr><td colspan="2" align="center">Modification des droits de <b>%s</b></td></tr>
                <tr><td><table><tr><td>mode</td></tr><tr><td><INPUT TYPE="text" NAME="mode" SIZE="4" value="%s"></td></tr></table></td>
                <td><table><tr><td>utilisateur</td><td>groupe</td>%s</tr>
                <tr><td><INPUT TYPE="text" NAME="user" value="%s"></td><td><INPUT TYPE="text" NAME="group" value="%s"></td>%s</tr>
                </table></td></tr><tr><td align="center" colspan="2">
                <INPUT TYPE="Submit" value="appliquer les permissions"/><input type="hidden" name="pass_var" value=""></FORM></td></tr></table>""" % (path, variante, module, path, mode, recurse_label, user, group, recurse_input)
                if var_owner == request.getUser():
                    self.content += """<FORM name="passform" onSubmit="return false;"><input type="hidden" name="passwd" value=""/></FORM>"""
                else:
                    self.content += """<br><FORM name="passform" onSubmit="return false;">Mot de passe <input type="password" name="passwd" value=""/></FORM>"""
            # gestion du contenu du fichier/répertoire
            if type(contenu) == list:
                # cas d'un répertoire, on affiche le contenu
                self.content +=  """<p><b>Contenu du répertoire</b></p><table border="1"><tr><td><table>"""
                for fic, f_info in contenu:
                    f_img = file_icons.get(f_info,'gnome-mime-text.png')
                    if f_info == 'missing':
                        # fichier non présent sur zephir
                        self.content += """<tr><td><img src="/images/%s">%s</td>\n""" % (f_img, fic)
                    else:
                        self.content += """<tr><td><img src="/images/%s"><a href="edit_fichier?id=%s&module=%s&file=%s&type=%s&localpath=%s">%s</a></td>\n""" % (f_img, variante, module, os.path.join(filename,fic),type_file,localpath,fic)
                    # lien de suppression
                    self.content += """<td align="right">(<a href="editvar?id=%s&module=%s&fic_sup=%s&type=%s">supprimer</a>)</td></tr>\n""" % (variante, module, path+os.sep+fic, type_file)
                self.content += """</table></td></tr></table>"""
            else:
                # formulaire de modification du contenu
                if contenu == "BINARY":
                    self.content += """<p>fichier non éditable (binaire)</p>
                    <a href=/module/editvar?id=%s&module=%s>retour</a>""" % (variante, module)
                else:
                    self.content += """
                    <FORM METHOD="POST" ACTION="save_file" onSubmit="return getpwd(this)">
                    <INPUT TYPE="hidden" NAME="filename" value="%s">
                    <INPUT TYPE="hidden" NAME="module" value="%s">
                    <INPUT TYPE="hidden" NAME="id" value="%s"><BR/>
                    <INPUT TYPE="hidden" NAME="type" value="%s"><BR/>
                    <INPUT TYPE="hidden" NAME="localpath" value="%s"><BR/>
                    <INPUT TYPE="hidden" NAME="pass_var" value=""/>
                    <textarea wrap="off" NAME="page" COLS="80" ROWS="16" STYLE="width: 90%%; heigth: 80%%">%s</textarea><br>
                    <INPUT TYPE="Submit" value="Sauvegarder"/>
                    </FORM>
                    <br/><a href=/module/editvar?id=%s&module=%s>retour</a>
                    """ % (filename,module,variante,type_file,basepath,base64.decodestring(contenu),variante,module)

        except Exception, e:
            self.content = e
            
        return self.content

class DeletePerms(Design):
    """Edition du fichier de permissions d'une variante (fichiers personnalisés)
    """
    isLeaf = True

    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "del_perms" :
            return self
        return Serveur()

    def wmfactory_title(self,request):
        return "(%s) Edition des permissions (suppression de permissions)" % request.getUser()

    def wmfactory_content(self, request):
        return self.content

    def renderView(self, request):
        try:
            var_owner = ""
            try:
                module = escape(request.args['module'][0])
                variante = escape(request.args['id'][0])
                module = int(module)
                variante = int(variante)
                detail_var=backend(proxy(request).modules.get_variante(variante))
                var_owner = detail_var[0]['owner']
            except:
                raise FrontendError
            try:
                delpath=escape(request.args['del_path'][0])
                pass_var = md5.md5(escape(request.args['pass_var'][0])).hexdigest()
            except:
                delpath=None
            # suppression des fichiers demandés
            if delpath != None:
                if delpath == "droits_zephir":
                    # toutes les permissions
                    backend(proxy(request).modules.del_variante_perms(variante,"",pass_var))
                else:
                    # permissions d'un chemin précis
                    backend(proxy(request).modules.del_variante_perms(variante,delpath,pass_var))
            # récupération du contenu
            permissions=backend(proxy(request).modules.get_variante_perms(variante))
            libel_variantes = self.get_variante(proxy(request))


            # génération du tableau des permissions existantes
            self.content = """<p><a href="/module/editvar?id=%s&module=%s">retour</a></p>""" % (variante, module)
            self.content += """<script LANGUAGE="JavaScript"><!--
            function getpwd(form)
            {
                //getting passwd from passwd field
                form.pass_var.value = document.forms['passform'].passwd.value;
                return true;
            }
            //--></script>"""
            if len(permissions) > 0:
                self.content += """<table border="1">
                <tr><td colspan="6" align="center"><b>Permissions définies sur la variante %s (%s)</td></tr>
                <tr><td>nom du fichier sur zephir</td><td><permissions</td><td>utilisateur</td><td>groupe</td><td>recursif</td><td></td></tr>""" % (libel_variantes[variante], variante)
                for ficperso, data in permissions.items():
                    check = ""
                    try:
                        perms, user, group, recurse = data
                        if recurse == True:
                            check = " checked"
                    except:
                        # droits non valides, ne devrait pas arriver
                        self.content += """<tr><td>%s</td><td colspan="4">Erreur de lecture des droits</td></tr>""" % ficperso
                    # formulaire de supression des permissions
                    self.content += """<tr><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td align="center">
                    <input type="checkbox" disabled %s></td><td>
                    <form method=POST action="/module/del_perms" onSubmit="return getpwd(this)">
                    <input type="hidden" name="id" value="%s">
                    <input type="hidden" name="module" value="%s">
                    <input type="hidden" name="del_path" value="%s">
                    <input type="hidden" name="pass_var" value="">
                    <input type="submit" value="Supprimer"></form>
                    </a></td></tr>""" % (ficperso, perms, user, group, check, variante, module, ficperso)
                if var_owner == request.getUser():
                    self.content += """<form name="passform" onSubmit="return false"><input type="hidden" name="passwd" value=""></form>"""
                else:
                    self.content += """<tr><td colspan="6" align="center"><form name="passform" onSubmit="return false"><input type="password" name="passwd">Mot de passe</form></td></tr>"""
                self.content += """<tr><td colspan="6" align="center">
                <form method=POST action="/module/del_perms" onSubmit="return getpwd(this)">
                <input type="hidden" name="id" value="%s">
                <input type="hidden" name="module" value="%s">
                <input type="hidden" name="del_path" value="droits_zephir">
                <input type="hidden" name="pass_var" value="">
                <input type="submit" value="Tout supprimer"></form>
                </td></tr></table>""" % (variante, module)
            else:
                self.content += """<p><font size=+1>Pas de permissions spécifiées pour cette variante</font></p>"""

        except Exception, e:
            self.content = e
            
        return self.content

class SavePerms(Design):
    """sauvegarde des permissions pour un fichier du serveur
    """
    isLeaf = True
    
    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "save_perms" :
            return self
        return Serveur()

    def wmfactory_title(self,request):
        return "(%s) sauvegarde des permissions" % request.getUser()

    def wmfactory_content(self, request):
        return self.content

    def renderView(self, request):
        try:
            try:
                filename = escape(request.args['filename'][0])
                variante = escape(request.args['id'][0])
                module = escape(request.args['module'][0])
                mode = escape(request.args['mode'][0])
                user = escape(request.args['user'][0])
                group = escape(request.args['group'][0])
                pass_var = md5.md5(escape(request.args['pass_var'][0])).hexdigest()
                assert variante
                assert module
                assert filename
                if request.args.has_key('recurse'):
                    recursive = True
                else:
                    recursive = False
            except:
                raise FrontendError

            # sauvegarde des permissions sur zephir
            rights = {filename:[mode, user, group,recursive]}
            backend(proxy(request).modules.set_variante_perms(int(variante),u(rights),u(pass_var)))
                
            self.content = """Permissions sauvegardées<BR>
            <a href=/module/editvar?id=%s&module=%s>retour</a>""" % (variante, module)

        except Exception, e:
            self.content = e
            
        return self.content

class SaveFile(Design):
    """sauvegarde du fichier d'une variante
    """
    isLeaf = True
    
    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "save_file" :
            return self
        return Module()

    def wmfactory_title(self,request):
        return "(%s) sauvegarde (fichier de variante)" % request.getUser()

    def wmfactory_content(self, request):
        return self.content

    def renderView(self, request):
        try:
            try:
                filename = escape(request.args['filename'][0])
                module = escape(request.args['module'][0])
                variante = escape(request.args['id'][0])
                contenu = request.args['page'][0]
                type_file = escape(request.args['type'][0])
                assert variante
                assert module
                assert filename
                assert contenu
            except:
                raise FrontendError
            if request.args.has_key('localpath'):
                localpath = request.args['localpath'][0]
            else:
                localpath = ""

            try:
                pass_var = md5.md5(escape(request.args['pass_var'][0])).hexdigest()
            except:
                pass_var = None
                    
            # sauvegarde du fichier sur zephir
            dic_files = {'dicos_var':[],'patchs_var':[],'persos_var':[],'fichiers_var':[],'rpms_var':[]}
            # on strippe les retour de ligne 'windows'
            win_new_line = chr(13)+chr(10)
            contenu=contenu.replace(win_new_line,'\n')
            dic_files[type_file].append([filename,base64.encodestring(contenu),localpath])
                     
            # mise en place des fichier
            if pass_var is not None:
                backend(proxy(request).modules.add_files(int(variante),dic_files,u(pass_var),True))
            else:
                backend(proxy(request).modules.add_files(int(variante),dic_files,"",True))
                
            self.content = """Fichier sauvegardé<BR>
            <a href=/module/editvar?id=%s&module=%s>retour</a>""" % (variante,module)

        except Exception, e:
            self.content = e
            
        return self.content


class MajDico(Design):
    """Mise à jour de dico.eol ou zephir.eol
    """
    isLeaf = True

    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "majdico" :
            return self
        return Serveur()

    def wmfactory_title(self,request):
        return "(%s) Modification de la configuration" % request.getUser()

    def wmfactory_content(self, request):
        return self.content

    def renderView(self, request):
        # réception des variables de formulaire
        try:
            try:
                id_module = escape(request.args['id_module'][0])
            except Exception:
                raise FrontendError("id module")
            try:
                # modification de dico.eol
                id_variante = escape(request.args['id_variante'][0])
                if id_variante:
                    pass_var = md5.md5(escape(request.args['pass_var'][0])).hexdigest()
            except:
                # modification de dictionnaire
                id_variante = None
            try:
                id_dico = escape(request.args['id_dico'][0])
            except:
                raise FrontendError("id dictionnaire")
            try:
                # récupération du dictionnaire dans la session
                prefs = request.getSession()
                dico_eole = prefs.dico_eole[id_dico]
                erreurs = {}
                ## on essaie de réinsérer toutes les valeurs
                fin = 0
                # on récupère la liste des variables de la famille
                nom,valeur,libelle,invisible,obligatoire,mime = dico_eole.get_first()
                while not fin:
                    # debug 
                    # print 'var '+nom+' -> '+str(valeur)
                    try:
                        dico_eole.set_value(valeur,invisible,force=True)
                    except Exception, e:
                        # les données entrées sont incorrectes
                        erreurs[convert(nom)]=str(e)
                    # on passe à la variable suivante
                    try:
                        nom,valeur,libelle,invisible,obligatoire,mime = dico_eole.get_next()
                    except:
                        # on est en fin de dictionnaire
                        fin = 1
                        
                # on regarde si des erreurs se sont produites
                if erreurs != {}:
                    # on affiche les messages d'erreur
                    self.content = """les données suivantes sont invalides :<br><br>
                    <table cellpadding="1" cellspacing="2" border="1">
                    <tr><td>variable</td><td>raison de l'échec</td></tr>"""
                    for var in erreurs.keys():
                        self.content += """<tr><td>%s</td><td>%s</td>""" % (var,erreurs[var])
                    self.content += """</table><br><a href="javascript:history.back()">retour à la saisie</a><br><br>"""
                else:
                    # pas d'erreurs, on sauvegarde le fichier sur zephir
                    try:
                        # récupération du contenu à sauvegarder et validation de l'ensemble du dictionnaire
                        dico_save = dico_eole.save(force=True)
                    except Exception, e:
                        self.content = """<br><a href="javascript:history.back()">retour à la saisie</a><br><br> """
                    else:
                        if dico_eole.version == 'creole1':
                            dico_save = base64.encodestring(dico_save)
                        else:
                            dico_save = dico_save
                        # envoi à zephir
                        if id_variante is None:
                            backend(proxy(request).modules.save_dico(dico_save,int(id_module)))
                            self.content = """Les données ont été sauvegardées sur zephir<br>
                            <a href="/module">Retour à la page des modules</a><br><br>"""
                        else:
                            backend(proxy(request).modules.save_dico(dico_save,int(id_module),int(id_variante),pass_var))
                            self.content = """Les données ont été sauvegardées sur zephir<br>
                            <a href="/module/getvar?id=%s">Retour à la page des variantes</a><br><br>""" % (id_module)
                        # on supprime le dictionnaire de la session
                        del(prefs.dico_eole[id_dico])

            except xmlrpclib.ProtocolError:
                raise BackendError("""Vous n'êtes pas autorisé à effectuer cette action""")
            except Exception, e:
                raise BackendError, e

        except (FrontendError,BackendError), e:
                self.content = str(e)
            
        return self.content

