# -*- coding: UTF-8 -*-
###########################################################################
# Eole NG - 2007  
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr 
#  
# utilisateurs.py
#  
# page web de gestion des utilisateurs
#       
###########################################################################
import twisted
try:
    assert twisted.__version__[0] == '2'
    from twisted.web import http
except:
    from twisted.protocols import http
from cgi import escape
import urllib
import time,os,tempfile,base64

from zephir.eolerpclib import xmlrpclib
from twisted.web import error,static
from twisted.web.woven import page, view
from twisted.web.resource import Resource
from zephir.web.template.design import Design, proxy
from zephir.web.template.page import IPreferences
from zephir.web.html.erreur import *
from twisted.python import components
from twisted.web import server
from zephir.web.config import Navigation
import zephir.web.config as config

js_check="""<SCRIPT LANGUAGE="JavaScript">
<!-- Begin
function CheckAll()
{
   count = document.frm.elements.length;
   for (i=0; i < count; i++) {
      if (document.frm.elements[i].type=="checkbox") {
          document.frm.elements[i].checked = 1;
      }
   }
}
function UnCheckAll()
{
   count = document.frm.elements.length;
   for (i=0; i < count; i++) {
       if (document.frm.elements[i].type=="checkbox") {
           document.frm.elements[i].checked = 0;
      }
   }
}
//  End -->
</script>"""

class Logout(Design):
    """
    """
    isLeaf=True

    def wmfactory_title(self,request):
        return "(%s) fermeture de session" % request.getUser()

    def wmfactory_content(self, request):
        return "<br><font center size=+2>Session fermée</font>"

    def renderView(self, request):
        session = request.getSession()
        session.expire()
        request.setHeader('WWW-authenticate', 'Basic realm="%s"' % ("zephir",))
        return self.content

class Preferences(Design):
    """Conteneur des pages de gestion des données utilisateur
    """
    def getChild(self, name, request):

        entites = {
            'modif_prefs':ModifPrefs()
            }
            # ,'affiche':AfficheUtilisateur()

        if static.isDangerous(name):
            return static.dangerousPathError
        if name in entites.keys():
            return entites[name]
        return self

    def wmfactory_title(self,request):
        return "(%s) préférences utilisateur" % request.getUser()

    def wmfactory_content(self, request):
        return self.content

    def wmfactory_menu(self, request):
        return Navigation(aide="page2.html#section2").menu()
    
    def boolean2checked(self,boolean):
        if boolean == 1:
            return "checked"
        else:
            return ""
        
    def formulaire(self, d):
        """création du contenu
        """
        l = ["""<table border=0 cellspacing=5>"""]
        l.append("""<h1>Informations utilisateur</h1>
        <script LANGUAGE="JavaScript"><!--
        function validfields(form)
        {
            //getting the values:
            if (form.nom.value.length > 40)
            {
                alert("nom : 40 caractères maximum !");
                form.nom.focus();
                return false;
            }
            if (form.prenom.value.length > 40)
            {
                alert("prenom : 40 caractères maximum !");
                form.prenom.focus();
                return false;
            }
            if (form.mail.value.length > 50)
            {
                alert("mail : 50 caractères maximum !");
                form.mail.focus();
                return false;
            }
            if (form.sms.value.length > 20)
            {
                alert("sms : 20 caractères maximum !");
                form.sms.focus();
                return false;
            }
            return true;
        }
        //--></script>
        <FORM method="post" action="/preferences/modif_prefs" enctype="multipart/form-data" onSubmit="return validfields(this)">
        <tr><td>nom</td><td><input type="text" name="nom" value="%(nom)s"/></td></tr>
        <tr><td>prénom</td><td><input type="text" name="prenom" value="%(prenom)s"/></td></tr>
        <tr><td>mail</td><td><input type="text" name="mail" value="%(mail)s"></td></tr>
        <tr><td>sms</td><td><input type="text" name="sms" value="%(sms)s" disabled/></td></tr>
        <tr><td>activation du mail</td><td><input type="checkbox" name="mail_actif" %(mail_actif)s/></td></tr>
        <tr><td>activation du sms</td><td><input type="checkbox" name="sms_actif" %(sms_actif)s disabled/></td></tr>
        <tr><td>clef ssh%(cle)s</td><td><input type="file" name="clef_ssh"/></td></tr>
        <tr><td colspan="2" align="center"><input type="submit" value="Modifier"</td></tr></form> """ % d)
        l.append("""</table><p><center><a href="/">retour à l'accueil<a>""")
        return "".join(l)
    
    def renderView(self, request):
        d = {}
        self.user = request.getUser()
        try:
            try:
                liste = backend(proxy(request).get_user(u(self.user)))
            except Exception, e:
                raise BackendError(e)
            else:
                d['mail'] = liste[1]
                d['sms'] = liste[4]
                d['sms_actif'] = self.boolean2checked(liste[6]) 
                d['mail_actif'] =  self.boolean2checked(liste[5])
                d['nom'] =  liste[2]
                d['prenom'] = liste[3]
                if liste[9] == 1:
                    d['cle'] = ' (présente) '
                else:
                    d['cle'] = ''
                self.content = self.formulaire(d)

        except (FrontendError,BackendError),e:
            self.content = e
            
        return self.content


class ModifPrefs(Design):
    """Conteneur des pages de gestion des données utilisateur
    """
    isLeaf = True

    def getChild(self, name, request):

        if static.isDangerous(name):
            return static.dangerousPathError
        if name == 'modif_prefs':
            return self
        return Preferences()

    def wmfactory_title(self,request):
        return "(%s) modification des informations utilisateur" % request.getUser()

    def wmfactory_content(self, request):
        return self.content

    def renderView(self, request):
        try:
            try:
                try:
                    if request.args['clef_ssh'][0]:
                        # récupération de la clef ssh
                        clef_ssh = base64.encodestring(request.args['clef_ssh'][0].rstrip())
                        # enregistrement de la clef ssh
                        backend(proxy(request).save_key(clef_ssh))
                except KeyError:
                    pass
                except:
                    raise BackendError("clef ssh")

                try:
                    request.args['mail_actif']
                    mail_actif = 1
                except KeyError:
                    mail_actif = 0
                try:
                    request.args['sms_actif']
                    sms_actif = 1
                except KeyError:
                    sms_actif = 0
                nom = escape(request.args['nom'][0])
                prenom = escape(request.args['prenom'][0])
                mail = escape(request.args['mail'][0])
                try:
                    sms = escape(request.args['sms'][0])
                except:
                    sms = ""
            except Exception, e:
                raise FrontendError(e)
            try:
                user = request.getUser()
                result = backend(proxy(request).edit_user(u(user),u(nom),u(prenom),u(mail),u(sms),u(mail_actif),u(sms_actif)))
                self.content = """Modifications effectuées<br>
                <p><a href="/preferences">Retour aux préférences</a></p>
                """
            except xmlrpclib.ProtocolError:
                return """Vous n'êtes pas autorisé à effectuer cette action"""
            except Exception, e:
                raise BackendError()

        except (FrontendError,BackendError),e:
            self.content = e
            
        return self.content



class Admin(Design):
    """Conteneur des pages d'administration
    """
    def getChild(self, name, request):

        entites = {
            'droits':DroitsUtilisateur()
            ,'modif_droits':ModifDroits()
            ,'del_user':DelUser()
            ,'conf_usb':ConfUsb()
            ,'gen_usb':GenUsb()
            ,'maj_client':MajClient()
            ,'del_client':DelClient()
            }

        if static.isDangerous(name):
            return static.dangerousPathError
        if name in entites.keys():
            return entites[name]
        return self

    def wmfactory_title(self,request):
        return "(%s) Administration" % request.getUser()

    def wmfactory_content(self, request):
        return self.content

    def wmfactory_menu(self, request):
        return Navigation(aide="howto/page8.html").menu()
    
    def formulaire(self,list_user, request):
        """génération de la page html"""
        rpm_zephir = []
        try:
            rpms=backend(proxy(request).list_client())
            for rpm in rpms:
                rpm_zephir.append(rpm + "&nbsp;<a href=/administration/del_client?paquet=%s>(supprimer)</a>" % rpm)
            if rpm_zephir == []:
                rpm_zephir = "pas de paquets disponible"
            else:
                rpm_zephir = "<BR/>".join(rpm_zephir)
        except:
            pass
        # recherche du denier client officiel disponible
        last_client = ''
        last_client_deb = []
        clients = {}
        url_failed = ''
        try:
            urllib.socket.setdefaulttimeout(3)
            # recherche des clients disponibles
            # parcours des différentes versions du client
            for version, infos in config.DISTRIBS.items():
                if version == 1:
                    try:
                        data =urllib.urlopen('ftp://' + config.CLIENT_UPDATE_HOST + config.CLIENT_UPDATE_URL)
                    except:
                        # timeout de la socket (par ex. si blocage par un pare-feu)
                        url_failed = """<font color=red>(Erreur d'accès à ftp://%s%s)</font>""" % (config.CLIENT_UPDATE_HOST, config.CLIENT_UPDATE_URL)
                        break
                    lines = data.read().split()
                    data.close()
                    for line in lines:
                        if line.count('zephir-client') > 0 and line.count('rpm') > 0:
                            last_client = line.strip()
                else:
                    update_url = config.CLIENT_NG_URL + '/%s' % infos[1]
                    data =urllib.urlopen('ftp://' + config.CLIENT_UPDATE_HOST + update_url)
                    lines = data.read().split()
                    data.close()
                    for line in lines:
                        if line.count('zephir-client') > 0 and line.count('deb') > 0:
                            last_client_deb.append('%s/%s' % (infos[1],line.strip()))
            urllib.socket.setdefaulttimeout(None)
        except Exception, e:
            pass
        l = []
        l.append( """<FORM METHOD='POST' ACTION='/administration/droits'><center><h1>Changement des droits d'un utilisateur</h1><table cellpadding='5' cellspacing='0' align='center' valign='middle' >""")
        if list_user is not None:
            l.append("""<tr><tr><td>Utilisateurs autorisés</td><td><select name="user">
                    <option selected value=""></option>""")
            for user in list_user:
                l.append("""<option value=%s>%s</option>""" % (user,user))
            l.append("""</select></td>""")
        l.append("""<td rowspan="2"><INPUT type='SUBMIT' value='OK' height='100%'></td></tr>""")
        l.append("""<tr><td>(autres utilisateurs)</td><td><input type="text" size="20" name="new_user" value=""></td></tr></table></form>""")
        l.append("""<p><h1>Fichiers pour clé usb</h1>
        <FORM METHOD='POST' ACTION="/administration/conf_usb">
        <INPUT type='SUBMIT' value="Générer un nouveau fichier de configuration"></FORM>
        </p>
        <script language="JavaScript"><!--
        function get_names ()
        {
            //getting the values:
            var val_dico = document.file_form.rpm.value;
            //setting the values:
            document.file_form.rpm_name.value = val_dico;
        }
        //--></script>
        <br/>
        <h1>Mise à jour automatique des clients</h1>%s
        <FORM name="file_form" METHOD="POST" ACTION="/administration/maj_client" enctype="multipart/form-data"  onSubmit="javascript:get_names()">
        <table border=0><tr><td>Version de zephir-client présente :</td><td>%s</td></tr></table><br/><br/>
        <INPUT NAME="rpm" TYPE="file"/><input type="hidden" name="deb_name" value="">
        <input type="hidden" name="rpm_name" value=""><INPUT type=SUBMIT value="Importer comme nouvelle version">
        </form><br/>""" % (url_failed, rpm_zephir))
        list_client = []
        if last_client != '':
            list_client.append(last_client)
        list_client.extend([os.path.basename(client) for client in last_client_deb])
        if list_client != []:
            l.append("""<FORM METHOD="POST" ACTION="/administration/maj_client">
            <input type=hidden name="rpm_name" value="%s">
            <input type=hidden name="deb_name" value="%s">
            <input type="submit" value="Récupérer les dernière version officielle \n%s"><br/>""" % (last_client,"|".join(last_client_deb),"\n".join(list_client)))
        l.append("""<br/><font size="-1" align="right">Version actuelle des paquets Zephir : %s</font>
        """ % config.VERSION_ZEPHIR)
        return "".join(l)
 
    def renderView(self, request):
        # récupération de la liste des utilisateurs ayant des droits si on le peut
        liste_users=None
        try:
            liste_users=backend(proxy(request).list_users())
        except:
            # on n'a pas les droits de gestion des utilisateurs
            pass
 
        self.content=self.formulaire(liste_users, request)

        return self.content


class DroitsUtilisateur(Design):
    """formulaire de gestion des droits d'un utilisateur
    """

    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "droits":
            return self
        return Admin()

    def sort_fonctions(self,a,b):
        if a[0]==b[0]:
            return 0
        elif a[0] > b[0]:
            return 1
        else:
            return -1

    def wmfactory_title(self,request):
        if not self.user:
            return "Erreur !"
        else:
            return "(%s) Autorisation de "  % request.getUser() + self.user

    def wmfactory_menu(self, request):
        return Navigation(aide="page2.html#section3").menu()
    
    def wmfactory_content(self, request):
        try:
            try:
                assert self.user != ""
            except:
                return """Nom d'utilisateur non défini"""
            # lecture des arguments dans le cas d'un ajout ou dune suppression
            update = ''
            try:
                update = escape(request.args['update'][0])
                assert update in ('add', 'del')
            except:
                pass
            else:
                type_res = escape(request.args['type_res'][0])
                id_res = escape(request.args['id_res'][0])
                if update == 'del':
                    backend(proxy(request).del_restriction(u(self.user), u(type_res), u(id_res)))
                else:
                    backend(proxy(request).add_restriction(u(self.user), u(type_res), u(id_res)))
            rights = backend(proxy(request).get_permissions(u(self.user)))
            groups = backend(proxy(request).get_rights())
            restrictions = backend(proxy(request).get_restrictions(u(self.user)))
            return self.formulaire(rights, groups, restrictions)
        except xmlrpclib.ProtocolError:
            return """Vous n'êtes pas autorisé à effectuer cette action"""
        except Exception, e:
            if update != '':
                return """Erreur de modification des restrictions (pas de ressource correspondante ?) <br><p><a href="/administration/droits?user=%s">retour à la page pécédente</a></p>""" % self.user
            else:
                return "erreur backend"

    def formulaire(self, rights_list, group_list, restrictions):
        """ affiche les autorisations d'un utilisateur 
        autorisations est une liste (de listes) contenant les noms des fonctions disponible
        et 1 ou 0 selon qu'elles sont autorisées ou non"""

        # convertis la liste de droits
        groupes = {}
        for groupe in group_list:
            groupes[groupe[0]] = groupe[1]

        if not self.user:
            return """<p>Vous devez saisir un nom d'utilisateur.<br>
        <a href="javascript:history.back()">retour</a></p>"""
        else:
            
            l = ["""<center><h1>Gestion des autorisations pour l'utilisateur %s</h1>"""%self.user]
            l.append("""<center><a href="administration/del_user?user=%s">Supprimer cet utilisateur de l'application</a></center>""" % self.user)
            l.append(js_check)
            l.append("""<table cellpadding='15' cellspacing='0' align='center' valign='middle' width='100%'><!--contenu2-->\n<tr><td align=center>""")
            l.append("""<table color="#9aacd5" border="0">\n<tr><td>""")
            l.append("""<table color="#9aacd5" border="1"> <!--cases à cocher-->""")
            l.append("""<FORM METHOD='POST' NAME='frm' ACTION='/administration/modif_droits'>""")
            l.append("""<input type="hidden" name="user" value="%s">""" % (self.user))
            l.append("""<tr><td colspan="2"><b><center>Fonctions autorisées</b><br>
                        <input type=button value="Toutes" onclick="CheckAll()">&nbsp;/&nbsp;
                        <input type=button value="Aucunes" onclick="UnCheckAll()"></center></td></tr>""")
            for groupe in groupes.keys():
                if groupe in rights_list:
                    coche = " checked "
                else:
                    coche = ""
                string = """<tr><td>%s</td><td><input type="checkbox" name="%s" %s></td></tr>""" % (groupes[groupe], str(groupe), coche)
                l.append(string)
            l.append("""<tr><td colspan="2" align="center"><INPUT type='SUBMIT' value='Modifier'></td></tr></FORM>\n</table></td><!--fin:cases à cocher-->
            """)
            # message si pas de groupes de droits
            if groupes.keys() == []:
                l.append("""<tr><td colspan="2">pas de fonctions référencées</td>""")

            # affichage des restrictions de l'utilisateur
            # table des restrictions
            l.append("""<td size="10%"></td><td>""")
            l.append("""<table color="#9aacd5" border="1"><tr><td colspan="3"><center><b>Limitation des ressources</b></center></td></tr><tr><td>type de ressource</td><td>identifiant autorisé</td><td></td></tr>""")
            select_type = """<select name="type_res">"""
            for type_res, data in config.type_res_label.items():
                libelle = data[0]
                select_type += """<option value="%s" selected>%s</option>""" % (type_res, libelle)
            select_type += """</select>"""
            if restrictions != []:
                for type_res in restrictions.keys():
                    if type_res in config.type_res_label.keys():
                        label = config.type_res_label[type_res][0]
                    else:
                        label = type_res
                    for id_res in restrictions[type_res]:
                        l.append("""<tr><td>%s</td><td>%s</td><td><a href=droits?user=%s&update=del&type_res=%s&id_res=%s>supprimer</a></td></tr>""" % (label, id_res, self.user, type_res, id_res))
            l.append("""<tr><FORM METHOD='POST' action='/administration/droits'><input type="hidden" name="user" value="%s">""" % (self.user))
            l.append("""<input type="hidden" name="update" value="add">
<td>%s</td><td><input type="text" name="id_res"></td>
<td><input type='submit' value='Ajouter'></td></FORM></tr>""" % select_type)
            l.append("""</table>""")
            l.append("""</td></tr>\n</table></td></table></td><!--fin:contenu2-->""")
            return "\n".join(l)
        

    def renderView(self, request):
        self.user = ""
        if request.args.has_key('new_user'):
            self.user = escape(request.args['new_user'][0])
        if self.user == "":
            try:
                self.user = escape(request.args['user'][0])
            except:
                pass
        # session dans self.prefs
        self.prefs=request.getSession()
        return self.content
           

class ModifDroits(Design):
    """Prise en compte des modifications
    """
    isLeaf = True

    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "modif_droits" :
            return self
        return Admin()

    def wmfactory_title(self,request):
        return "(%s) Modification de "  % request.getUser() + self.user

    def wmfactory_content(self, request):
        # tentative de modification des autorisations
        try:
            group_list = backend(proxy(request).get_rights())
        except xmlrpclib.ProtocolError:
            return """Vous n'êtes pas autorisé à effectuer cette action"""
        except Exception:
            return "erreur backend"

        # convertis la liste de droits
        groupes = {}
        for groupe in group_list:
            groupes[groupe[0]] = groupe[1]
                
        new_perms=[ int(i) for i in self.modifs ]
        libelles=[ groupes[i] for i in new_perms ]
        try:
            proxy(request).save_permissions(self.user,new_perms)
        except xmlrpclib.ProtocolError:
            return """<br>Vous n'avez pas la permission d'ajouter des autorisations !<br><br>"""
        except Exception:
            return "erreur backend"
        else:
            l=["nouvelles autorisations pour %s :<BR>%s" % (self.user, "<BR>".join(libelles))]
            l.append("""<br><a href="/administration">retour</a></p>""")
            return "".join(l)
        
    def renderView(self, request):
        self.modifs = request.args.keys()
        self.modifs.remove('user')
        # récupération de la session dans self.prefs
        self.prefs=request.getSession()
        self.user=escape(request.args['user'][0])
        return self.content

class DelUser(Design):
    """Prise en compte des modifications
    """
    isLeaf = True

    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "del_user" :
            return self
        return Admin()

    def wmfactory_title(self,request):
        return "(%s) Suppression de "  % request.getUser() + self.user

    def wmfactory_content(self, request):
        return self.content

    def renderView(self, request):
        self.user=escape(request.args['user'][0])
        if request.args.has_key('confirm'):
            try:
                backend(proxy(request).del_user(u(self.user)))
            except xmlrpclib.ProtocolError:
                self.content = """Vous n'êtes pas autorisé à effectuer cette action.<p><a href="/administration">retour</a></p>"""
            except Exception, e:
                self.content = """Erreur lors de la suppression : %s<p><a href="/administration/modif_droits?user=%s">retour</a></p>""" % (str(e), self.user)
            else:
                self.content = """Suppression effectuée.<p><a href="/administration">retour</a></p>"""
        else:
            # page de confirmation
            self.content = """<p><a href="/administration/del_user?user=%s&confirm=yes">Confirmer la suppression de %s""" % (self.user, self.user)
            self.content += """<p><a href="/administration/droits?user=%s">retour</a></p>""" % self.user
        return self.content

class MajClient(Design):
    """Met à jour le rpm de zephir-client mis à dispo sur le site
    """
    isLeaf = True

    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "maj_client" :
            return self
        return Admin()

    def wmfactory_title(self,request):
        return "(%s) Mise à jour du rpm" % request.getUser()

    def wmfactory_content(self, request):
        return self.content

    def renderView(self, request):
        try:
            try:
                # on récupère le fichier et son nom
                nom = escape(request.args['rpm_name'][0])
                nom_deb = escape(request.args['deb_name'][0]).split("|")
            except Exception:
                raise FrontendError("paquet zephir-client")
            try:
                contenu = request.args['rpm'][0]
                contenu = base64.encodestring(contenu)
            except:
                contenu = ""
            try:
                self.content = ""
                nom_deb.insert(0,nom)
                for paquet in nom_deb:
                    if paquet != "":
                        paquet = paquet.replace('\\','/')
                        if not os.path.basename(paquet).startswith('zephir-client'):
                            self.content = """Ce fichier n'est pas un rpm zephir-client (%s) !<br/>""" % paquet
                        else:
                            backend(proxy(request).update_client(u(paquet), contenu))
                            self.content += """<p>Fichier mis à jour (%s)</p>""" % paquet
                self.content += """<p><a href="/administration">retour au menu d'administration</a></p>"""
            except:
                raise BackendError("erreur de mise en place du client")
            
        except Exception, e:
            self.content = e
            
        return self.content

class DelClient(Design):
    """supprime un rpm de zephir-client mis à dispo sur le site
    """
    isLeaf = True

    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "del_client" :
            return self
        return Admin()

    def wmfactory_title(self,request):
        return "(%s) Suppression du rpm" % request.getUser()

    def wmfactory_content(self, request):
        return self.content

    def renderView(self, request):
        try:
            try:
                # on récupère le fichier et son nom
                nom = request.args['paquet'][0]
            except Exception:
                raise FrontendError("paquet zephir-client")
            try:
                nom=os.path.basename(nom.replace('\\','/'))
                if not nom.startswith('zephir-client'):
                    self.content = """Ce fichier n'est pas un rpm zephir-client !<br/>
                    <p><a href="/administration">retour au menu d'administration</a></p>"""
                else:
                    # on supprime le fichier.
                    backend(proxy(request).remove_client(u(nom)))
                    self.content = """<p>Fichier supprimé</p><p><a href="/administration">retour à la page d'administration</a></p>"""
            except Exception, e:
                raise BackendError("erreur lors de la suppression du rpm : %s" % str(e))
            
        except Exception, e:
            self.content = e
            
        return self.content

class ConfUsb(Design):
    """Formulaire de création d'un fichier de données pour clé usb
    """
    isLeaf = True
    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "conf_usb" :
            return self
        return Admin()

    def wmfactory_menu(self, request):
        return Navigation(aide="page11.html").menu()
    
    def wmfactory_title(self,request):
        return "(%s) Saisie des données" % request.getUser()

    def wmfactory_content(self, request):
        return """<h1><center>Saisie des valeurs par défaut<br>(Les champs vides seront ignorés)</h1></br>
<FORM METHOD=POST ACTION="gen_usb">
<table cellpadding="8" cellspacing="0" align="center" valign="middle" >
<tr><td>adresse du serveur zephir </td><td><input type=text size="20" name="adresse_zephir" value="%s"></td></tr>
<tr><td>mettre en place une config. réseau minimale </td><td><select name="conf_net">
    <option selected value="">&nbsp;</option>
    <option value="oui">oui</option>
    <option value="non">non</option>
</select></td></tr>
<tr><td>interface réseau ayant accès à zephir</td><td><input type=text size="6" name="interf" value="eth0"></td></tr>
<tr><td>adresse ip de cette interface</td><td><input type=text size="16" name="ip_eth0" value=""></td></tr>
<tr><td>masque réseau de cette interface</td><td><input type=text size="16" name="mask_eth0" value=""></td></tr>
<tr><td>passerelle par défaut</td><td><input type=text size="16" name="gateway" value=""></td></tr>
<tr><td><INPUT name="submit" type=SUBMIT value="Générer le fichier"></td>
<td><input name="initialiser" value="INITIALISER" type="reset" />
</td></tr>
<tr><td colspan="2" align="center"><a href="/administration">Retour au menu administration</a></td></tr>
</table>
</form>
""" % (config.ADRESSE_ZEPHIR)

class GenUsb(Design):
    """Génération effective d'un fichier de configuration pour cle usb
    """
    isLeaf = True

    def getChild(self, name, request):
        if static.isDangerous(name):
            return static.dangerousPathError
        if name == "gen_usb" :
            return self
        return Admin()

    def wmfactory_title(self,request):
        return "(%s) Génération de fichier pour clé usb - Téléchargement" % request.getUser()

    def wmfactory_content(self, request):
        return self.content

    def formulaire(self, contenu):
        self.content = """<h1>Le fichier doit être placé à la racine d'une clé usb sous le nom zephir.conf</h1>
        <br><br><br>contenu du fichier :<br><br>"""
        self.content += """<table><tr><td align="left">""" + "<br>".join(contenu) + """</td></tr></table>"""
        # lien sur le fichier temporaire
        filename = "zephir-" + os.path.basename(tempfile.mktemp()) + ".conf"
        # on vérifie que le répertoire temporaire existe
        if not os.path.isdir(config.PATH_TEMP):
            os.makedirs(config.PATH_TEMP)
        f=file(os.path.join(config.PATH_TEMP,filename),"w")
        f.write("\n".join(contenu))
        f.close()
        self.content += """
        <br><a href="/tmp/%s">Télécharger (clic droit->enregistrer sous)</a><br/>
        <a href="javascript:history.back()">Retour</a><br/>
        """ % filename
            
    def renderView(self, request):
        try:
            # récupération des champs non vides
            contenu = ["""# Fichier de configuration pour la procédure enregistrement zephir"""]
            try:
                adresse_zephir = escape(request.args['adresse_zephir'][0])
            except KeyError:
                pass
            else:
                if adresse_zephir != "":
                    contenu.append('adresse_zephir="%s"' % adresse_zephir)
            try:
                conf_net = escape(request.args['conf_net'][0])
            except KeyError:
                pass
            else:
                if conf_net != "":
                    contenu.append('conf_net="%s"' % conf_net)
            try:
                interf= escape(request.args['interf'][0])
            except KeyError:
                pass
            else:
                if interf != "":
                    contenu.append('interf="%s"' % interf)
            try:
                ip_eth0 = escape(request.args['ip_eth0'][0])
            except KeyError:
                pass
            else:
                if ip_eth0 != "":
                    contenu.append('ip_eth0="%s"' % ip_eth0)
            try:
                mask_eth0 = escape(request.args['mask_eth0'][0])
            except KeyError:
                pass
            else:
                if mask_eth0 != "":
                    contenu.append('mask_eth0="%s"' % mask_eth0)
            try:
                gateway = escape(request.args['gateway'][0])
            except KeyError:
                pass
            else:
                if gateway != "":
                    contenu.append('gateway="%s"' % gateway)

                
        except Exception,e:
            self.content = e 
        else:
            self.formulaire(contenu)

        return self.content

